unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus,
  ComCtrls, Spin, _Measure, _String, _Math;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpContentsItem: TMenuItem;
    HelpSearchItem: TMenuItem;
    HelpHowToUseItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    StatusLine: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    PrintSetupDialog: TPrinterSetupDialog;
    SpeedBar: TPanel;
    SpeedButton1: TSpeedButton;  { &Save }
    SpeedButton2: TSpeedButton;  { &Undo }
    SpeedButton3: TSpeedButton;  { &About... }
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Edit4: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Edit14: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Edit15: TEdit;
    Edit16: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Edit9: TEdit;
    Label19: TLabel;
    Edit10: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Edit11: TEdit;
    Label22: TLabel;  { &Search for Help On... }
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FilePrintSetup(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure WindowTile(Sender: TObject);
    procedure WindowCascade(Sender: TObject);
    procedure WindowArrange(Sender: TObject);
    procedure HelpContents(Sender: TObject);
    procedure HelpSearch(Sender: TObject);
    procedure HelpHowToUse(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure NumKeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FileNew(Sender: TObject);
begin
  { Add code to create a new file }
end;

procedure TMainForm.FileOpen(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    { Add code to open OpenDialog.FileName }
  end;
end;

procedure TMainForm.FileSave(Sender: TObject);
begin
   { Add code to save current file under current name }
end;

procedure TMainForm.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    { Add code to save current file under SaveDialog.FileName }
  end;
end;

procedure TMainForm.FilePrint(Sender: TObject);
begin
  if PrintDialog.Execute then
  begin
    { Add code to print current file }
  end;
end;

procedure TMainForm.FilePrintSetup(Sender: TObject);
begin
  PrintSetupDialog.Execute;
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditUndo(Sender: TObject);
begin
  { Add code to perform Edit Undo }
end;

procedure TMainForm.EditCut(Sender: TObject);
begin
  { Add code to perform Edit Cut }
end;

procedure TMainForm.EditCopy(Sender: TObject);
begin
  { Add code to perform Edit Copy }
end;

procedure TMainForm.EditPaste(Sender: TObject);
begin
  { Add code to perform Edit Paste }
end;

procedure TMainForm.WindowTile(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowCascade(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowArrange(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.HelpContents(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TMainForm.HelpSearch(Sender: TObject);
const
  EmptyString: PChar = '';
begin
  Application.HelpCommand(HELP_PARTIALKEY, Longint(EmptyString));
end;

procedure TMainForm.HelpHowToUse(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TMainForm.HelpAbout(Sender: TObject);
begin
  { Add code to show program's About Box }
end;

procedure TMainForm.NumKeyPress(Sender: TObject; var Key: Char);
var
  t:TEdit;
  s:String;
begin
  t := (sender as TEdit);
  s := t.text;
//  Edit4.Text := inttostr(edit1.SelStart);

   if not CheckFloat(s ,key, t.SelStart) then
    begin
      key := #0;
//      beep;
//      if Pasword.Enabled then Pasword.SetFocus;
    end;

end;

procedure TMainForm.Edit1Change(Sender: TObject);
var
  kmHour, widthMeters, sqMetersHour, sqMetersMin:real;
begin
  if (not (Sender as TEdit).Modified) or ( not TEdit(Sender).Focused) then exit;
  if Sender = Edit1 then
    begin
      if (Edit1.Text <> '') then
	Edit2.Text := FloatToStr(MetersToFeet(StrToFloat(Edit1.Text)))
      else
        Edit2.Text := '0';
    end
  else if Sender = Edit2 then
    begin
      if (Edit2.Text <> '') then
	Edit1.Text := FloatToStr(FeetToMeters(StrToFloat(Edit2.Text)))
      else
	Edit1.Text := '0';
    end
  else if Sender = Edit3 then
    begin
      if (Edit3.Text <> '') then
	Edit4.Text := FloatToStr(kmToMiles(StrToFloat(Edit3.Text)))
      else
	Edit4.Text := '0';
    end
  else if Sender = Edit4 then
    begin
      if (Edit4.Text <> '') then
	Edit3.Text := FloatToStr(MilesTo_km(StrToFloat(Edit4.Text)))
      else
	Edit3.Text := '0';
    end
  else if Sender = Edit11 then
    begin
      if (Edit11.Text <> '') then
      begin
	Edit3.Text := FloatToStr(0.1/StrToFloat(Edit11.Text)*60*60);
	Edit4.Text := FloatToStr(kmToMiles(StrToFloat(Edit3.Text)));
      end
      else begin
	Edit4.Text := '0';
	Edit4.Text := '0';
      end;
    end;
  kmHour := StrToFloat(Edit3.Text);
  if Edit1.Text = '' then widthMeters := 0
  else widthMeters := StrToFloat(Edit1.Text);
  sqMetersHour := widthMeters * (kmHour * 1000);
  sqMetersMin := sqMetersHour / 60;
  Edit15.Text := FloatToStr(sqMetersMin);
  Edit16.Text := FloatToStr(sqmTosqyd(sqMetersMin));
  Edit10.Text := FloatToStr((kmHour/60)*1000);

  if (Sender = Edit3) or (Sender = Edit4) then
  begin
    if kmHour = 0 then Edit11.Text := '-'
    else Edit11.Text := FloatToStr(1 / ((kmHour*1000)/(60*60)) * 100);
  end;
  if Sender = Edit5 then
    begin
      if (Edit5.Text <> '') then
	begin
	  Edit6.Text := FloatToStr(kgPerHectareToLbPerAcre(StrToFloat(Edit5.Text)));
	  Edit9.Text := FloatToStr(lbTokg(StrToFloat(Edit6.Text)));
	end
      else begin
	Edit6.Text := '0';
	Edit9.Text := '0';
      end;
    end
  else if Sender = Edit6 then
    begin
      if (Edit6.Text <> '') then
      begin
	Edit5.Text := FloatToStr(LbPerAcreTokgPerHectare(StrToFloat(Edit6.Text)));
	Edit9.Text := FloatToStr(lbTokg(StrToFloat(Edit6.Text)));
      end
      else begin
	Edit5.Text := '0';
	Edit9.Text := '0';
      end
    end;
  if Sender = Edit9 then
    begin
      if (Edit9.Text <> '') then
      begin
        Edit6.Text := FloatToStr(kgTolb(StrToFloat(Edit9.Text)));
        Edit5.Text := FloatToStr(LbPerAcreTokgPerHectare(StrToFloat(Edit6.Text)))
      end
      else begin
        Edit5.Text := '0';
        Edit6.Text := '0';
      end
    end;
  if Edit5.Text = '' then Edit14.Text := '0'
  else Edit14.Text := FloatToStr(StrToFloat(Edit5.Text)/10000);
  if Edit14.Text = '' then Edit7.Text := '0'
  else Edit7.Text := FloatToStr(StrToFloat(Edit14.Text) * sqMetersMin);
  if Edit7.Text = '' then Edit8.Text := '0'
  else Edit8.Text := FloatToStr(kgToLb(StrToFloat(Edit7.Text)));

//  Edit16.Text := FloatToStr(kgPerHectareToLbPerAcre(sqMetersMin));
end;

procedure TMainForm.Edit1Click(Sender: TObject);
begin
  (Sender as TEdit).SelectAll;
end;

procedure TMainForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Edit4.Text := inttostr(edit1.SelStart);
end;

end.
