unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, _Dos;//,
  //classes;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    FileExitItem: TMenuItem;
    StatusLine: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    PrintSetupDialog: TPrinterSetupDialog;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FilePrintSetup(Sender: TObject);
    procedure FileExit(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FileNew(Sender: TObject);
begin
  { Add code to create a new file }
end;

procedure TMainForm.FileOpen(Sender: TObject);
var
  stream: TFileStream;
  FileBufferSize: Integer;
  iBytesRead: Integer;
  Buffer: PChar;
  f:string;
begin
  if OpenDialog.Execute then
  begin
    f:= OpenDialog.FileName;
    stream := TFileStream.Create(F, fmOpenRead or fmShareDenyWrite);
    try
      FileBufferSize := 1024 * 5000; //5MB
      buffer := AllocMem(FileBufferSize + 1);
      try
        repeat
          iBytesRead := stream.Read(buffer^,FileBufferSize);
        until iBytesRead < 1;
      finally
        FreeMem(Buffer);
      end;
    finally
      stream.Free;
    end;
  end;
end;

procedure TMainForm.FileSave(Sender: TObject);
begin
   { Add code to save current file under current name }
end;

procedure TMainForm.FileSaveAs(Sender: TObject);
type
  t = array of byte;
var
  stream: TFileStream;
  FileBufferSize: Integer;
  {iBytesRead,} x: Integer;
  Buffer: PChar;
  f:string;
begin
  if SaveDialog.Execute then
  begin
    f:= SaveDialog.FileName;
    stream := TFileStream.Create(F, fmOpenWrite or fmShareDenyWrite);
    try                              //copymem
      FileBufferSize := 1024 * 5000; //5MB
      buffer := AllocMem(FileBufferSize + 1);
      try
//      for x := 1 to (FileBufferSize ) - 1  do t(buffer^)[x] := $f;
        for x := 1 to 50 do
          {iBytesRead  := }stream.write(buffer^,FileBufferSize);
      finally
        FreeMem(Buffer);
      end;
    finally
      stream.Free;
    end;
  end;
    { Add code to save current file under SaveDialog.FileName }
end;

procedure TMainForm.FilePrint(Sender: TObject);
begin
  if PrintDialog.Execute then
  begin
    { Add code to print current file }
  end;
end;

procedure TMainForm.FilePrintSetup(Sender: TObject);
begin
  PrintSetupDialog.Execute;
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
  Close;
end;

end.
