{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T+,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
//{$WARNINGS OFF}
{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE Off}
{$H+}
Unit _Buffers;

INTERFACE
uses SysUtils;
Const BufferO_RangeChecking : Boolean = true;
Type
  StringT = array of char;
  pStringT = ^StringT;
  ListP = ^List;
  List = Record
	   Next : ListP;
	   length: integer;
	   s    : StringT;
	 end;
  ListP2 = ^List2;
  List2 = Record
	    Next : ListP2;
	    p    : Pointer;
	  end;

  BufferO = Class
	      Constructor Create;
	      Destructor Destroy; override;

	      Procedure Add (s:string);
	      Procedure Clr;
	      procedure Concat (var t2 : BufferO);
	      Procedure Del (n:word);
	      Procedure Ins (s:string; n:word);
	      Procedure Ovr (s:string; n:word);
	      Procedure Sort;
	      Procedure SortNumeric;
	      Procedure Swop(n, n2:Word);
	      Procedure Move(n, n2:word);
	      Function  Find(s : String; n : Word; caseS : Boolean): Word;
	      Function  Get (n:word):string;
	      Function	GetValueN(s:string):Integer;
	      Function	GetValue(s:string):String;
	      Function	ValueExists(s:string):Boolean;
	      Procedure	SetValueN(s:string;v:Integer);
	      Function  Len : Word;
	      Function  Longest : Word;
	      Function  InBufCountBefore(s:string; n:word):Word;
	    Private
	      buf	: ListP;
	      last	: ListP;
	      lastPos	: Word;
	      size	: Word;
	      Procedure CopyStringToBlock(s:String;p :listP);
	      function CompareBlock(p1, p2: listP):integer;
	      Procedure CopyBlockToString(var s:String;p :listP);
	      function StrFromBlock(p: listP): string;
	      Procedure GetAddr(var p : ListP; n : Word);
	      Procedure SetAddr(n : Word; p : ListP);
	    end;

  PointerBufO = Object
		  Constructor Init;
		  Destructor Done;

		  Procedure Add (pIn:Pointer);
		  Procedure Clr; virtual;
		  Procedure Concat(var t2 : PointerBufO);
		  Procedure Del (n:word);
		  Procedure Ins (pIn : Pointer; n:word);
		  Procedure Ovr (pIn : Pointer; n:word);
		  Function  Find(pIn : Pointer): Word;
		  Function  Get (n:word):Pointer;
		  Function  Len : Word;
		Private
		  buf	: ListP2;
		  last	: ListP2;
		  lastPos	: Word;
		  size	: Word;
		  Procedure GetAddr(var p : ListP2; n : Word);
		  Procedure SetAddr(n : Word; p : ListP2);
		end;
E_Buffer_Error	= class(Exception);

Function LoadBuffer(var b : bufferO; s:string): Word;
Function SaveBuffer(var buf : bufferO; s:string): Word;

IMPLEMENTATION

Uses _Dos, _code, _String;

{*************************begin BufferO********************************}
Constructor BufferO.Create;
begin
  buf := Nil;
  last := Nil;
  lastPos := 1;
  size := 0;
end;

Destructor BufferO.Destroy;
begin
  Clr;
end;

Procedure BufferO.SetValueN(s:string;v:Integer);
begin
  if ValueExists(s) then ovr(s+'='+IntToStr(v), Find(s+'=',length(s)+1,false))
  else Add(s+'='+IntToStr(v));
end;

Function BufferO.ValueExists(s:string):Boolean;
begin
  result := Find(s+'=',length(s)+1,false) > 0;
end;

Function BufferO.GetValueN(s:string):Integer;
var
  x:Word;
  t:String;
begin
  x := Find(s+'=',length(s)+1,false);
  if x > 0 then
  begin
    t := Get(x);
    t := DelFirst(t,FindFirstC(t,'='));
    t := DelAllButK(t,c0To9);
    result := StrToInt(t);
  end
  else result := 0;
end;

Function BufferO.GetValue(s:string):String;
var
  x:Word;
  t:String;
begin
  x := Find(s+'=',length(s)+1,false);
  if x > 0 then
  begin
    t := Get(x);
    t := DelFirst(s,FindFirstC(t,'='));
    result := t;
  end
  else result := '';
end;

procedure BufferO.Concat(var t2 : BufferO);
Const
  P : ListP = Nil;
begin
   if t2.size < 1 then exit
   else if LongInt(size) + t2.size > 65535 then
    raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Concat:'+ErrorCode(522))
   else begin
     size := size + t2.size;
     SetAddr((size - t2.size) + 1, t2.buf);
     t2.buf := Nil;
     t2.size := 0;
     t2.last := nil;
     t2.lastPos := 0;
   end;
end;

Procedure BufferO.Add (s:string);
var
  p : ListP;
  length1 : longint;
begin
   length1 := Length(s);
   if LongInt(size) + 1 > 65535 then
    begin
      raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Add:'+ErrorCode(522));
      exit;
    end;
  try
    GetMem(p, length1 {Length(s)} + sizeOf(list));
  except
    on EOutOfMemory do raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Add:'+ErrorCode(520));
  end;
   if p=nil then runerror(520);
  CopyStringToBlock(s,p);
  p^.next := Nil;
  Inc(size);
  SetAddr(size, p);
end;

Procedure BufferO.Clr;
begin
  if self = Nil then exit;
  while size > 0 do
    del(1);
end;

Procedure BufferO.Del (n:word);
const
  p : ListP = Nil;
begin
   if n < 1 then
    begin if BufferO_RangeChecking then Raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Del:'+ErrorCode(523)); end
   else if n <= size then
    begin
       if n = size then
	begin
	  GetAddr(p, Size);
	  dec(Size);
	   if p<>nil then FreeMem(p, p^.Length + sizeOf(listP))
	    else begin
	      //InOut(521, 1, 140);
	      RunError(521);
	    end;
	end
	else begin
	  GetAddr(p, n);
	  Dec(size);
	  SetAddr(n, p^.Next);
	  if p<>nil then FreeMem(p, p^.Length + sizeOf(listP))
	  else raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Del:'+ErrorCode(521));
	end;
    end;
end;

Procedure BufferO.Ins (s:string; n:word);
Const
  p : ListP = Nil;
begin
   if n = 0 then
    begin Inc(n);
       if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Ins:'+ErrorCode(523));
    end;
   While (n > size + 1) {and (TestInOutError = False)} do
    Add('');
   {if GetLastInOutError <> 0 then InOut(GetLastInOutError, 1, 160)}
   {else }if n > size then Add(s)
    else begin
       if (LongInt(size) + 1 > 65535) then
	begin
	   if LongInt(size) + 1 > 65535 then E_Buffer_Error.Create('Error in _Buffers.BufferO.Ins:'+ErrorCode(522));
	  exit;
	end;
      try
	GetMem(p, Length(s) + sizeOf(list));
      except
	on EOutOfMemory do raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Ins:'+ErrorCode(520));
      end;
       if p=nil then begin raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Ins:'+ErrorCode(520)); Exit; end;
      CopyStringToBlock(s, p);
      GetAddr(p^.next, n);
      SetAddr(n, p);
      Inc(size);
    end;
end;

Procedure BufferO.Ovr (s:string; n:word);
Const
  p  : ListP = Nil;
  p2 : ListP = Nil;
  iOR	: Word = 0;
begin
  iOR := 0;
   if n = 0 then
    begin inc(n); if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Ovr:'+ErrorCode(523)); end;
   While (n > size + 1) {and (TestInOutError = False)} do
    Add('');
   if n > size then Add(s)
    else begin
      GetAddr(p, n);
       if p^.length = Length(s) then
	begin
          CopyStringToBlock(s,p);
	end
	else begin
	  try
	    GetMem(p2, Length(s) + sizeOf(list));
	  except
	    on EOutOfMemory do raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Ovr:'+ErrorCode(520));
	  end;
	  if p2=nil then runerror(520);
	  p2^.next := p^.next;
          CopyStringToBlock(s,p2);
	  SetAddr(n, p2);
	  FreeMem(p, p^.Length + sizeOf(listP));
	end;
    end;
end;

Procedure BufferO.Sort;
const p:ListP=nil;
      n:ListP=nil;
      c:word=1;
      d:word=1;
      x:word=1;
begin
   if size > 1 then
    begin
      p:=buf;
      n:=buf^.next;
      c:=2;
       while (c<=size) do
	begin
	   if CompareBlock(p, n) <= 0 then
	    begin
	      p:=n;
	      n:=n^.next;
	      inc(c);
	    end
	    else begin
	       p:=buf;
	       d:=1;
		while CompareBlock(p, n) <= 0 do
		 begin
		   inc(d);
		   p:=p^.next;
		 end;
	       SetAddr(c, n^.next);
	       GetAddr(n^.next,d);
	       SetAddr(d, n);
	       inc(c);
	       GetAddr(p, c-1);
	       n:=p^.next;
	    end;
	end;
    end;
end;

Procedure BufferO.SortNumeric;
const p:ListP=nil;
      n:ListP=nil;
      c:word=1;
      d:word=1;
      x:word=1;
begin
   if size > 1 then
    begin
      p:=buf;
      n:=buf^.next;
      c:=2;
       while (c<=size) do
	begin
	   if (StrToNum(StrFromBlock(p)) <= StrToNum(StrFromBlock(n))) then
	    begin
	      p:=n;
	      n:=n^.next;
	      inc(c);
	    end
	    else begin
	       p:=buf;
	       d:=1;
		while StrToNum(StrFromBlock(p)) <= StrToNum(StrFromBlock(n)) do
		 begin
		   inc(d);
		   p:=p^.next;
		 end;
	       SetAddr(c, n^.next);
	       GetAddr(n^.next,d);
	       SetAddr(d, n);
	       inc(c);
	       GetAddr(p, c-1);
	       n:=p^.next;
	    end;
	end;
    end;
end;


Procedure BufferO.Swop(n, n2:Word);
var
  addr_n, addr_n2, pTo_n, pTo_n2, save_n_next:	ListP;
  x:		Word;
begin
   if (n > size) or (n2 > size) then
    begin if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Swop:'+ErrorCode(523)); Exit; end;
   if n = n2 then exit;
   if (n = 0) or (n2 = 0) then exit;
   if n > n2 then
    begin
      x:=n;
      n:=n2;
      n2:=x;
    end;
   if n <> 1 then GetAddr(pTo_n, n-1);
  GetAddr(addr_n, n);
  GetAddr(pTo_n2, n2-1);
  GetAddr(addr_n2, n2);
  pTo_n2^.next := addr_n;
  save_n_next := addr_n^.next;
  addr_n^.next := addr_n2^.next;
  addr_n2.Next := save_n_next;
   if n = 1 then
    begin
      buf := addr_n2;
    end
    else begin
      pTo_n^.next := addr_n2;
    end;
end;

Procedure BufferO.Move(n, n2:Word);
var
  p:	ListP;
begin
//  InOutZ;
   if (n > size) or (n2 > size) or
      (n = 0) or (n2 = 0) then
    begin if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Swop:'+ErrorCode(523)); Exit; end;
   if n = n2 then exit;
  //remove n
  GetAddr(p, n);
   if n <> size then SetAddr(n, p^.Next) else
   SetAddr(n, nil);
  // insert at n2
  GetAddr(p^.next, n2);
  SetAddr(n2, p);
end;

Function  BufferO.Find(s : String; n : Word; caseS : Boolean): Word;
Function TruncateTo(s : String; n : word): String;
begin
  if Length(s) > n then
  SetLength(s, n);
  TruncateTo := s
end;
Function SUpCase(s : String) : String;
  var
    i : Integer;
  begin
    for i := 1 to Length(s) do
      s[i] := UpCase(s[i]);
    SUpCase := s;
  end;
var
  t: String;
Const
  x : Word = 1;
begin
  x := 1;
  t := TruncateTo(s, n);
   if not caseS then
    begin
      t := SUpCase(s);
      While (x <= size) and (SUpCase(TruncateTo(get(x), n)) <> t) do Inc(x);
    end
    else While (x <= size) and (TruncateTo(get(x), n) <> t) do Inc(x);
   if x > size then x := 0;
  Find := x;
end;

Function  BufferO.InBufCountBefore(s:string; n:word):Word;
var
  x:Word;
//How many times is s in the buffer
begin
  result := 0;
  if n > len then n := len;
  for x := 1 to n do
  begin
    if s = get(x) then inc(result);
  end;
end;

Function  BufferO.Get (n:word):string;
const
  p : ListP = nil;
begin
   if n > size then
    begin Get := ''; if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Get:'+ErrorCode(523)); end
   else if n < 1 then
    begin Get := ''; if BufferO_RangeChecking then raise E_Buffer_Error.Create('Error in _Buffers.BufferO.Get:'+ErrorCode(524)); end
    else begin
      GetAddr(p , n);
      Get := StrFromBlock(p);
    end;
end;

Function  BufferO.Len:Word;
begin
  Result := Size;
end;

Function  BufferO.Longest : Word;
Var
  p : listP;
  x, c, l : Word;
begin
   if Size = 0 then c := 0
    else begin
      p := Buf;
      l := Length(p^.s);
      c := 1;
       for x := 1 to Size - 1 do
	begin
	  p := p^.next;
	   if Length(p^.s) > l Then
	    begin
	      c := x + 1;
	      l := Length(p^.s);
	    end;
	end;
    end;
  Longest := c;
end;


{******Private******}


Procedure BufferO.CopyStringToBlock(s:String;p :ListP);
begin
  system.move(pointer(s)^, p^.s, length(s));
  p^.length := length(s);
end;

Procedure BufferO.CopyBlockToString(var s:String;p :listP);
begin
  SetLength(s,p^.length);
  system.move(p^.s ,pointer(s)^,p^.length);
end;

function BufferO.StrFromBlock(p: listP): string;
begin
  CopyBlockToString(Result, p);
end;

function BufferO.CompareBlock(p1, p2: listP):integer;
var
  s1, s2: String;
begin
  s1 := StrFromBlock(p1);
  s2 := StrFromBlock(p2);
  if s1 = s2 then result := 0
  else if s1 > s2 then result := 1
  else result := -1;
end;


Procedure BufferO.SetAddr(n : Word; p : ListP);
begin
   if n < 1 then RunError(523);
   if n > size then RunError(523);
   if n = 1 then
    begin
      buf := p;
      last := p;
      LastPos := 1;
    end
    else begin
       if (lastPos > n - 1) then
	begin
	  lastPos := 1;
	  last := Buf;
	end;
       while lastPos < n - 1 do
	begin
	  inc(lastPos);
	  last := last^.next;
	end;
      last^.next := p;
    end;
end;
(* Assembler;
asm
	push	edi
	push	esi
	push	ebx
	mov	edi, self
	mov	cx, n
	cmp	cx, 1			{if n < 1 then RunError(523);}
	jnb	@s1
	mov	ax, 523
	push	ax
	call	RunError
@s1:	mov	ax, [edi].size	{if n > size then RunError(523);}
	cmp	cx, ax
	jna	@s2
	mov	ax, 523
	push	ax
	call	RunError
@s2:	cmp	cx, 1			{if n = 1 then begin}
	jne	@e1
{begin}	mov	eax, p		{buf := p;}
	mov	[edi].buf, eax
	mov	esi, [edi].buf
	mov	eax, List([esi]).Next
	mov	[edi].last, eax
	mov	eax, List([esi]).Next
	mov	[edi].last, eax
	mov	[edi].LastPos, 2	{LastPos := 2;}
	jmp	@ende1
{end else begin}
@e1:	cmp	[edi].lastPos, cx
	jb	@s3			{if not (lastPos < n) then}
{begin}	mov	[edi].lastPos, 1	{lastPos := 1;}
	mov	eax, [edi].buf	{last := Buf;}
	mov	[edi].last, eax
{end;}
@s3:	push	ds			{for x := lastPos to n - 2 do last := last^.next;}
	mov	esi, [edi].last
	mov	bx, [edi].lastPos
	dec	cx
@l1:	cmp	bx, cx
	je	@f1
	inc	bx
	mov	esi, list([esi]).next
	jmp	@l1
@f1:	mov	[edi].last, esi
	mov	ax, ds
{	mov	[edi].last.word(2), ax}
	mov     eax, p		{last^.next := p;}
	mov	list([esi]).next, eax
{	mov     ax, p.word(2)
	mov	list([esi]).next.word(2), ax}
	pop	ds
	mov	[edi].lastPos, cx	{lastPos := n - 1;}
{end;}
@ende1:
	pop	ebx
	pop	esi
	pop	edi
end;
*)

Procedure BufferO.GetAddr(var p : ListP; n : Word);
begin
   if n < 1 then RunError(523);
   if n > size then RunError(523);
   if n = 1 then
    begin
      p := buf;
      last := p;
      LastPos := 1;
    end
    else begin
       if (lastPos > n) then
	begin
	  lastPos := 1;
	  last := Buf;
	end;
       while lastPos < n do
	begin
	  inc(lastPos);
	  last := last^.next;
	end;
      p := last;
    end;
end;
(*  {	Assembler;}
begin
asm
	push	edi
	push	esi
	push	ebx
	mov	edi, self
	mov	ax, n
	cmp	ax, 1		{if n < 1 then RunError(523);}
	jnb	@s1
	mov	ax, 523
	push	ax
	call	RunError
@s1:	cmp	ax, [edi].size	{if n > size then RunError(523)}
	jna	@s2
	mov	ax, 523
	push	ax
	call	RunError
@s2:	cmp	[edi].lastPos, ax	{if lastPos > n then}
	jna	@s3			{begin}
	mov	[edi].lastPos, 1	{lastPos := 1;}
	mov	edx, [edi].Buf		{last := Buf;}
	mov	[edi].last, edx
{	mov	dx, [edi].Buf.word(2)}
{	mov	[edi].last.word(2), dx	}{end;}
@s3:	mov	cx, [edi].lastPos
	push	ds
	mov	esi, [edi].last
@l1:	cmp	cx, ax			{for x := lastPos to n - 1 do last := last^.next;}
	jae	@el1
	inc	cx
	mov	esi, list([esi]).next
	jmp	@l1
@el1:	mov	dx, ds
	pop	ds
	mov	[edi].last, esi
{	mov	[edi].last(2), dx}
	mov	[edi].lastPos, ax			{lastPos := n;}
	mov	edi, p				{p := last;}
	mov	[edi], si
{	mov	[edi].word(2), dx}
	pop	ebx
	pop	esi
	pop	edi
end;
end;*)
{**************************End BufferO************************}

{*************************begin PointerBufO********************************}
Constructor PointerBufO.Init;
begin
  buf := Nil;
  last := Nil;
  lastPos := 1;
  size := 0;
end;

Destructor PointerBufO.Done;
begin
   while size > 0 do
     del(1);
   Init;
end;

procedure PointerBufO.Concat(var t2 : PointerBufO);
Const
  P : ListP = Nil;
begin
//  InOutZ;
   if LongInt(size) + t2.size > 65535 then //InOut(522, 1, 479)
   else begin
     SetAddr(size + 1, t2.buf);
     size := size + t2.size;
     t2.buf := Nil;
     t2.size := 0;
     t2.last := nil;
     t2.lastPos := 0;
   end;
end;

Procedure PointerBufO.Add (pIn : Pointer);
Const
  p : ListP2 = Nil;
begin
//  InOutZ;
   if {(MaxAvail < 8) or }(LongInt(size) + 1 > 65535) then
    begin
       if LongInt(size) + 1 > 65535 then //InOut(522, 1, 497)
       else //InOut(520, 1,498);
      exit;
    end;
  GetMem(p, 8);
  if p=nil then runerror(520);
  p^.p := pIn;
  p^.next := Nil;
  Inc(size);
  SetAddr(size, p);
end;

Procedure PointerBufO.Clr;
begin
  Done;
end;

Procedure PointerBufO.Del (n:word);
const
  p : ListP2 = Nil;
begin
   if n < 1 then
   else if n <= size then
    begin
       if n = size then
	begin
	  GetAddr(p, Size);
	  if p<>nil then FreeMem(p, 8)
		    else runerror(521);
	  Dec(size);
	end
	else begin
	  GetAddr(p, n);
	  Dec(size);
	  SetAddr(n, p^.Next);
	  if p<>nil then FreeMem(p, 8)
		    else runerror(521);
	end;
    end;
end;

Procedure PointerBufO.Ins (pIn:Pointer; n:word);
Const
  p : ListP2 = Nil;
begin
//  InOutZ;
   if n = 0 then inc(n);
   While (n > size + 1) {and {(TestInOutError = False)} do Add(Nil);
//   if GetLastInOutError <> 0 then InOut(GetLastInOutError, 1, 545)
  { else} if n > size then Add(pIn)
    else begin
       if {(MaxAvail < 8) or }(LongInt(size) + 1 > 65535) then
	begin
	   if LongInt(size) + 1 > 65535 then //InOut(522, 1, 550)
	   else //InOut(520, 1, 551);
	  exit;
	end;
      GetMem(p, 8);
       if p=nil then runerror(520);
      p^.p := pIn;
      GetAddr(p^.next, n);
      SetAddr(n, p);
      Inc(size);
    end;
end;

Procedure PointerBufO.Ovr (pIn:Pointer; n:word);
Const
  p  : ListP2 = Nil;
  p2 : ListP2 = Nil;
  iOR	: Word = 0;
begin
  iOR := 0;
//  InOutZ;
   if n = 0 then inc(n);
   While (n > size + 1) {and (TestInOutError = False)} do Add(Nil);
//   if GetLastInOutError <> 0 then InOut(GetLastInOutError, 1, 573)
  { else} if n > size then Add(pIn)
    else begin
      GetAddr(p, n);
      p^.p := pIn;
    end;
end;

Function  PointerBufO.Find(pIn : Pointer): Word;
Const
  x : Word = 1;
begin
  x := 1;
   While (x <= size) and (get(x) <> pIn) do Inc(x);
   if x > size then x := 0;
  Find := x;
end;

Function  PointerBufO.Get (n:word):Pointer;
const
  p : ListP2 = nil;
begin
   if n > size then Get := Nil
   else if n < 1 then Get := Nil
    else begin
      GetAddr(p , n);
      Get := p^.p;
    end;
end;

Function  PointerBufO.Len:Word;
begin
  Len := Size;
end;

{******Private******}

Procedure PointerBufO.SetAddr(n : Word; p : ListP2);
var
  x : Word;
begin
  if n < 1 then RunError(530);
   if n >= size + 1 then RunError(531);
   if n = 1 then
    begin
      buf := p;
      last := buf^.Next;
      LastPos := 2;
    end
    else begin
       if lastPos < n then
	begin
	   for x := lastPos to n - 2 do last := last^.next;
	  last^.next := p;
	  lastPos := n - 1;
	end
	else begin
	  last := Buf;
	   for x := 1 to n - 2 do  last := last^.next;
	  last^.next := p;
	  lastPos := n - 1;
	end
    end;
end;

Procedure PointerBufO.GetAddr(var p : ListP2; n : Word);
var
  x : Word;
begin
   if n < 1 then
   RunError(530);
   if n > size then
   RunError(531)
    else begin
       if lastPos <= n then
	begin
	   for x := lastPos to n - 1 do last := last^.next;
	  p := last;
	  lastPos := n;
	end
	else begin
	  last := Buf;
	   for x := 1 to n - 1 do last := last^.next;
	  lastPos := n{x + 1};
	  p := last;
	end;
    end;
end;
{**************************End PointerBufO************************}

Function loadbuffer(var b : bufferO; s:string): Word;
var
  f		: text;
  line		: string;
  iOR, temp	: Word;
begin
   if s = '' then iOR := 600
    else begin
      {$I-}
      IOResult;
      assign(f,s);
      Reset(f);
      iOR := IOResult;
    end;
  if iOR = 0 then
    begin
{      settextbuf(f,buf);}
       while (not eof(f)) and (iOR = 0) do
	begin
	  readln(f,line);
	  iOR := IOResult;
	   if iOR = 0 then
	    begin
	      b.Add(line);
{	       if TestInOutError then iOR := GetLastInOutError;}
	    end;
	end;
      close(f);
      temp := IOResult;
       if temp <> 0 then iOR := temp
      {$I+}
    end;
  loadbuffer := iOR;
end;

function SaveBuffer(var buf : bufferO; s:string): Word;
var
  f		:text;
  x, iOR	: Word;
begin
  {$I-}
  AssignFile(f,s);
  Rewrite(f);
  iOR := IOResult;
   if iOR = 0 then
    begin
      x:= 1;
      While x <= Buf.size do
       begin
	 WriteLn(f,buf.get(x));
	 iOR := IOResult;
	  if iOR <> 0 then x := Buf.Size + 1;
	 inc(x);
       end;
      close(f);
      iOR := IOResult;
    end;
   {$I+}
   SaveBuffer:= iOR;
end;

END.