unit _DirTree;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, _LoadTree, Menus, ConstDef,_Dos;

type
  TChDir = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TreeView1: TTreeView;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function GetNodePath:string;
  public
    { Public declarations }
    function LoadTree(dir:string; var sub:String; cap: String):Word;
    Procedure MakeDir;
 end;
		   // TTreeNode
var
  ChDir: TChDir;

implementation

{$R *.DFM}

function TChDir.GetNodePath:string;
var
 node:	TTreeNode;
 x:	Word;
begin
  node := chDir.TreeView1.Selected;
   if (node <> nil) then
    begin
      x := node.Level;
      Result := '';
       while x >= 1 do
	begin
	   if result = '' then Result := node.Text
	   else Result := node.Text+'\'+result;
	  node := node.Parent;
	  x := node.Level;
	end;
    end
   else result := '';
end;

function TChDir.LoadTree(dir:string; var sub:String; cap: String):Word;
var
 oldSub:	string;
begin
  oldSub := sub;
  Caption := cap;
  _LoadTree.LoadTree(TreeView1,dir, sub);
  Result := ChDir.ShowModal;
   if Result = mrOk then
    begin
      sub := GetNodePath;
    end
    else sub := oldSub;
  ChDir.TreeView1.Items.Clear;
end;


procedure TChDir.FormShow(Sender: TObject);
begin
  TreeView1.SetFocus;
end;

Procedure TChDir.MakeDir;
var
  temp:		String;
  mrResult:	Integer;
  InputString:	string;
begin
  mrResult := LoadTree(RootDir, temp, 'Please chooses a host dir');
  if mrResult = mrOk then
    begin
      InputString := 'New dir';
      if InputQuery('New directory', 'Type In a name:', InputString) then
	begin
	  InputString := FileName(InputString);
	  if InputString <> '' then
	    begin
	      if temp = '' then mrResult := MessageDlg('About to create directory "' +
				InputString + '" In the root spelling directory', mtConfirmation, [mbOK, mbCancel], 0)

	      else mrResult := MessageDlg('About to create directory "' +
				InputString + '" as a sub dir of "' + temp + '"', mtConfirmation, [mbOK, mbCancel], 0);
	      if mrResult = mrOk then _dos.CreateDir(rootDir + temp + '\' + InputString + '.spl\');
	    end;
	end;
    end;
end;

end.
