{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W+,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
(*{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V+,X-}*)

Unit _Dos;
Interface
uses SysUtils;

Const
  ErrorCheck:	Boolean = True;
{$WARNINGS OFF}
  p:		Pointer = nil;
{$WARNINGS ON}
  EnvirLength:	Word = 160;
  errorInUnit:	Word = 0;
  errorLine:	Word = 0;

Type
  S1		= String[1];
  s10		= String[10];
  NameExtStr	= String[12];
  PSPSegT	= Word;
  WordT		= Word;
  comstr	= String;
  dirStr	= string;
  ExtStr	= String[3];
  nameStr	= String[8];
  E_Dos_Error	= class(Exception);

Var
    InOutProc	: Procedure;
    x		: Word;

{Procedure SaveRegisters2;  				{Assembler}
{Procedure SetProc(Var proc; p: Pointer); {Assembler;}


{************************ Start of Reboot routine ********************}
{Procedure Reboot; Inline($EA/$00/$00/$FF/$FF); {jmp $FFFF:$0000}
Procedure ColdReboot;
Procedure WarmReboot;
{************************ End of Reboot routine ********************}

{************************ Start of InOut error routine ********************}
const
  traceStackSize = 20;
  LockIO	:Boolean = false;
type
  UnitET = (U_Win2, U_Dos, U_String, U_KeyB);
  TraceStackT = record
		  u	: UnitET;
		  line	: Word;
		end;
var
  traceStack		: array[1..TraceStackSize] of TraceStackT;
  traceSP, TraceSPOld	: word;
//Procedure InOut(in1, unit1, line : Word);		{Assembler;}
//Procedure InOutAsm; {Assembler;}
//Procedure InOutErrorAsm; {Assembler;}
//Procedure InOutZ; {Assembler;}
Procedure RunError(e : Word);
//Procedure TraceError(u : UnitET; line : Word);
//Function InOutError : Boolean;
//Function TestInOutError : Boolean;
//Function GetLastInOutError: Word;
//Procedure WriteTrace;
{************************ End of InOut error routine ********************}

{************************ Start of Sound routine ********************}
Procedure SoundFor(hz, d : Word);
{************************ Start of Sound routine ********************}

{************************ Start of Time routine ********************}
Function Time : LongInt{real};              { Time in H.S.}
Function TimeLapst(var tL  : LongInt; timeL : LongInt) : Boolean;
function UnCodeTime(Time: TDateTime):string;
{************************ End of Time routine ********************}

{************************ Start of Date routine ********************}
Function GetDateS: String;
Function GetTimeS: String;
function UnCodeDate(Date: TDateTime):string;
{************************ End of Date routine ********************}

{************************ Start of dir routine ********************}
Procedure CreateSubDir(dir,ext:string);
Procedure MDir(name:ComStr);
Procedure MoveDir(d, d2:ComStr);
function RemoveDir(d:ComStr):word;

{Function CToFileDir(FileName : ComStr) : DirStr;}
Function GetDirCurrent : DirStr;
Function TestDir(name: ComStr):Boolean;
Function Open(f : String):Word;
{************************ End of dir routine ********************}

{************************ Start of file routine ********************}
Function CopyFile(f, f2:String):Word;
Procedure MoveFile(f, f2:String);
Function ReadTextFileLine(f : String;n : word) : String;
Function FileSizeText(f : String) : LongInt;
{************************ End of file routine ********************}

Procedure MotorOff(in1 : Byte);


Function CreateFile(f:String):Word;
Function DeleteFile(f:String):Word;
Function CreateDir(f:String):Word;
{FilePath is used so add a \ on the end is f is only a dir}
Function DriveExists(in1 : String) : Boolean;
Function FilePath(s : String) : String;
Function FileDir(s : String) : String;
Function FileDrive(s : String) : String;
{Function FileExists(FileName: string): Boolean;}
Function FileExt(s : String) : String;		//use ExtractFileExt
Function FileName(s : String) : String;
Function MakeSureInDir(s,d: String):Boolean;
Function FileNameExt(s : String) : String;


Function Test(f : string): Boolean;
Function TestOpen(f : String):Boolean;

Function GetDrive : S1;


Implementation

uses _Delay, _String, _Code, Dialogs, Classes;

Const
  InOutError1		: Boolean = False;
  InOutError2		: Boolean = False;
  InOutErrorCode        : Word = 0;

{Procedure SetProc(Var proc; p: Pointer); Assembler;
asm
	les	di, proc
	mov	ax, p.word(2)
	mov	[es:di].word(2), ax
	mov	ax, p.word
	mov	[es:di].word(0), ax
begin
   proc := p;
end;}

{$WARNINGS OFF}
Procedure MotorOff(in1 : Byte); Assembler;
asm
  xor	eax, eax
  mov	es, eax
  mov	edi, $440
  mov	al, in1
  mov	[es:edi], al
end;{$WARNINGS ON}

Function DriveExists(in1 : String) : Boolean;
var
  s : String;
begin
  GetDir(0,s); { 0 = Current drive }
  {$I-}
   if InString(s,':') then in1 := FileDrive(in1)
   else if length(in1) = 1 then in1 := in1+':'
   else
     begin
       Result := false;
       exit;
     end;
  ChDir(in1);
  {$I+}
  if IOResult <> 0 then DriveExists := False else DriveExists := True;
  ChDir(s);
end;


Function FileExists(FileName: string): Boolean;
{ Returns True if file exists; otherwise,
  it returns False. Closes the file if
  it exists. }
var
  f: file;
begin
  {$I-}
  Assign(f, FileName);
  Reset(f);
  Close(f);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

Function FilePath(s : ComStr) : DirStr;
begin
   if InStringC(s,'\') then
    result := Split2(s, FindLastC(s, '\')) + '\'
   else Result := '';
end;

Function FileDir(s : ComStr) : DirStr;
begin
   if InStringC(s,'\') then
    begin
      s := Split2(s, FindLastC(s, '\')) + '\';
      if InStringC(s,':') then Split2(s, FindLastC(s, ':'));
    end
   else s := '';
  FileDir := s;
end;

Function FileDrive(s : String) : String;
begin
   if InStringC(s,':') then
    s := Split2(s, FindLastC(s, ':')) + ':'
   else s := '';
  result := s;
end;

Function FileExt(s : ComStr) : String;
var
  n: byte;
begin
  if InString(s, '.') then
   begin
     n := FindLastC(s,'.');
     Split2(s, n);
     result := s;
   end
   else Result := ''
end;

Function MakeSureInDir(s,d: String):Boolean;
begin
  s := SUpCase(s);
  d := SUpCase(d);
   if CompareFromTo(s, d, 1, length(d)) then Result := true
   else Result := false;
end;

Function FileName(s : string) : String;
begin
   if InStringC(s, '.') then
    s := Split2(s, FindLastC(s, '.'));
   if InStringC(s, '\') then
    Split2(s, FindLastC(s, '\'));
   if InStringC(s, ':') then
    Split2(s, FindLastC(s, ':'));
  Result := s;
end;

Function FileNameExt(s : string) : string;
begin
   if InStringC(s, '\') then
    Split2(s, FindLastC(s, '\'));
   if InStringC(s, ':') then
    Split2(s, FindLastC(s, ':'));
  Result := s;
end;

Function ReadTextFileLine(f : ComStr; n: Word) : String;
Var
  f2 : Text;
  count : LongInt;
  line:	String;
begin
  result := '';
   if n < 1 then exit;
   if not FileExists(f) then Exit;
  count := 0;
  Assign(f2, f);
  Reset(f2);
   while (not Eof(f2)) and (count < n) do
    begin
      ReadLn(f2, line);
      inc(count);
    end;
  Close(f2);
  if count = n then result := line;
end;

Function FileSizeText(f : ComStr) : LongInt;
Var
  f2 : Text;
  temp : LongInt;
begin
   if not FileExists(f) then begin FileSizeText := 0; Exit; end;
  temp := 0;
  Assign(f2, f);
  Reset(f2);
   while not Eof(f2) do
    begin
      ReadLn(f2);
      temp := temp + 1;
    end;
  Close(f2);
  FileSizeText := temp
end;

Function GetDirCurrent : DirStr;
var
  s : DirStr;
begin
  GetDir(0, s);
  GetDirCurrent := s;
end;

Function GetDrive : S1;
var
  s : S1;
begin
  GetDir(0, s);
  GetDrive := s;
end;

{************************ Start of Date routine ********************}
function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

function IntToStr(i: Longint): string;
{ Convert any Integer type to a string }
var
  s: string[11];
begin
  Str(i, s);
  IntToStr := s;
end;


Function GetDateS: String;
var
  year, month, day : Word;
begin
  DecodeDate(Now, Year, Month, Day);
  result := LeadingZero(day)+'/'+LeadingZero(month)+'/'+IntToStr(year);
end;

Function GetTimeS: String;
var
  Hour, Min, Sec, MSec:Word;
begin
  DecodeTime(Now, Hour, Min, Sec, MSec);
  result := LeadingZero(Hour)+':'+LeadingZero(Min)+':'+LeadingZero(Sec);
end;

function UnCodeTime(Time: TDateTime):string;
var
  Hour, Min, Sec, MSec: Word;
begin
  DecodeTime(Time, Hour, Min, Sec, MSec);
  result := LeadingZero(Hour)+':'+LeadingZero(Min)+':'+LeadingZero(Sec);
end;

function UnCodeDate(Date: TDateTime):string;
var
  Year, Month, Day: Word;
begin
  DecodeDate(date, Year, Month, Day);
  result := LeadingZero(day)+'/'+LeadingZero(month)+'/'+IntToStr(year);
end;

{************************ End of Date routine ********************}

{************************ Start of dir routine ********************}
Procedure CreateSubDir(dir, ext:string);
var
  InputString: string;
begin
  InputString := 'New dir';
   if InputQuery('New directory', 'Type In a name:', InputString) then
    begin
      InputString := FileName(InputString);
       if InputString <> '' then
	begin
	  CreateDir(dir+InputString+ext+'\');
	end;
    end;
end;

Procedure MDir(name:ComStr);
Var
  x:	Word;
begin
  //InOutZ;
  while name[length(name)] = '\' do SetLength(name, Length(name) - 1);
{$I-}
  MkDir(name);
  x := IOResult;
{$I+}
   if x <> 0 then raise E_Dos_Error.Create('Error in _dos.MDir:'+ErrorCode(x)) //InOut(x, 4, 294);
end;

Procedure MoveDir(d, d2:ComStr);
begin

end;

function RemoveDir(d:ComStr):Word;
begin
{$I-}
  while (d[length(d)] = '\') do (SetLength(d, Length(d) - 1)) ;
  RmDir(d);
  result := IOResult;
{$I+}
end;
{************************ End of dir routine ********************}


{************************ Start of file routine ********************}
procedure CopyFile2(f1, f2: String);
var
  streamFrom, streamTo: TFileStream;
begin
  streamFrom := TFileStream.Create(f1, fmOpenRead or fmShareDenyWrite);
  try
    streamTo := TFileStream.Create(f2, fmCreate or fmShareDenyWrite);
    try
      streamTo.CopyFrom(streamFrom, 0);
    finally
      streamTo.Free;
    end;
  finally
    streamFrom.Free;
  end;
end;

Function CopyFile(f, f2:ComStr):Word;
var
  FromF, ToF:		file;
  NumRead, NumWritten:	Integer;
  buf:			array[1..2048] of Char;
  error:		word;
  label end2;
begin
  { Open input file }
   if not  test(f) then
    begin
      CopyFile := 2;
      exit;
    end;
  Assign(FromF, f);
  error := IOResult;
   if error <> 0 then goto end2;
 { Record size = 1 }
  Reset(FromF, 1);
  error := IOResult; 
   if error <> 0 then goto end2;
  { Open output file }
  Assign(ToF, f2);
  error := IOResult;
   if error <> 0 then goto end2;
  { Record size = 1 }
  Rewrite(ToF, 1);
  error := IOResult;
   if error <> 0 then goto end2;
  WriteLn('Copying ', FileSize(FromF),
	  ' bytes...');
  repeat
    {$WARNINGS OFF}
    BlockRead(FromF,buf,SizeOf(buf),NumRead);
    error := IOResult;
     if error <> 0 then goto end2;
    BlockWrite(ToF,buf,NumRead,NumWritten);
    {$WARNINGS ON}
    error := IOResult;
     if error <> 0 then goto end2;
  until (NumRead = 0) or
	(NumWritten <> NumRead);
end2:
  Close(FromF);
  error := IOResult;
  Close(ToF);
   if error = 0 then error := IOResult;
  CopyFile := error;
end;

Procedure MoveFile(f, f2:ComStr);
begin
end;
{************************ End of file routine ********************}

{*********************** Start of Save bp, sp, ds, ss*****************}
{asm
  pushf
  stc
  push	cs
  mov	ax, offset @Save
  push  ax
  call	SaveRegisters
  clc
  jmp	SaveRegisters
  nop
  nop
  nop
  nop
  nop
  nop
@Save:
end; the jmp SaveRegisters2 return's to the instrutshon after the pointer
push't on the sack in the first call to SaveRegisters}

{type mt=array [1..100] of word;
var m:^mt;}

{$F+}
(*Procedure SaveRegisters2; Assembler;
{if carry set then save registers, and ret else restore registers}
{when you save (carry flag set) you must push the flags and then the address
to return to when you restore registers (restore sp value before pushf)}
{when you save registers: call SaveRegister. When you restore register: jmp
SaveRegisters}
{when you save register it store's the register's in a internal stack in code
segment. a maximum of 10 save register's deep at one time}
{if there are no save register's on the internal stack then SaveRegisters
calls runerror(570)}
{if there is no room to save register's on the internal stack then
SaveRegister's call's RunError(571)}
asm
  jc	@Save
  jmp	@Restore
  @Temp:	dw	0
  @StackP:	db	0
  @SaveCS:	dw      0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveIP:	dw      0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveBP:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveSP:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveDS:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveSS:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveAX:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveDX:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveCX:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveBX:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveSI:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveDI:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @SaveES:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  @Flags:	dw	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
@Restore:
  xor	bx, bx
  mov	bl, [cs: @StackP.Byte]
  cmp	bl, 0
  jne	@s2
  mov	ax, 570
  push	ax
  call	RunError
@s2:
  dec	bl
{  mov	sp, [cs:@SaveSP.word + bx]}
  mov	bp, [cs:@SaveBP.Word + bx]
  push	[cs:@SaveCS.Word + bx]
  push	[cs:@SaveIP.Word + bx]
  mov	ds, [cs:@SaveDS.Word + bx]
  mov	ss, [cs:@SaveSS.Word + bx]
  mov	ax, [cs:@SaveAX.Word + bx]
  mov	dx, [cs:@SaveDX.Word + bx]
  mov	cx, [cs:@SaveCX.Word + bx]
  mov	si, [cs:@SaveBX.Word + bx]
  mov	cs:@temp.word, si
  mov	si, [cs:@SaveSI.Word + bx]
  mov	di, [cs:@SaveDI.Word + bx]
  mov	es, [cs:@SaveES.Word + bx]
  dec	cs:@StackP.Byte
  push	[cs:@Flags.word + bx]
  popf
  mov	bx, cs:@temp.word
  retf
@Save:
  mov	cs:@temp.word, bx
  mov	bl, cs:@StackP.Byte
  xor	bh, bh
  cmp	bx, 10
  jb	@s1
  mov	ax, 571
  push	ax
  call	RunError
@s1:
  inc	cs:@StackP.Byte
  mov	[cs:@SaveAX.Word + bx], ax
  mov	[cs:@SaveDX.Word + bx], dx
  mov	[cs:@SaveCX.Word + bx], cx
  mov	ax, cs:@temp.word
  mov	[cs:@SaveBX.Word + bx], ax
  mov	[cs:@SaveSI.Word + bx], si
  mov	[cs:@SaveDI.Word + bx], di
  mov	[cs:@SaveES.Word + bx], es
  pop	di
  pop	es
  pop	ax
  mov   [cs:@SaveIP.Word + bx], ax
  pop	ax
  mov   [cs:@SaveCS.word + bx], ax
  pop	ax
  mov	[cs:@Flags.word + bx], ax
  mov	[cs:@SaveBP.Word + bx], bp
  mov	[cs:@SaveSP.Word + bx], sp
  mov	[cs:@SaveDS.Word + bx], ds
  mov	[cs:@SaveSS.Word + bx], ss
  push	es
  push	di
end;*)
{$F-}
{*********************** end of Save bp, sp, ds, ss*****************}


{************************ Start of Reboot routine ********************}
(*Procedure Reboot; Inline($EA/$00/$00/$FF/$FF); {jmp $FFFF:$0000}*)
{$WARNINGS OFF}
Procedure ColdReboot; assembler;
asm
  xor	ax, ax
  mov	ds, ax
  mov	ds:[$472], $0000.Word
  db	$EA, $00, $00, $FF, $FF		{jmp $FFFF:$0000}
end;

Procedure WarmReboot; assembler;
asm
  xor	ax, ax
  mov	ds, ax
  mov	ds:[$72], $1234.Word
  db	$EA, $00, $00, $FF, $FF		{jmp $FFFF:$0000}
end;{$WARNINGS ON}
{************************ End of Reboot routine ********************}

{************************ Start of Sound routine ********************}
Procedure SoundFor(hz, d : Word);
begin
  beep;
{  NoSound;
  Sound(hz);}
  Delay(d);
{  NoSound;}
end;
{************************ Start of Sound routine ********************}

{************************ Start of Time routine ********************}
Function Time : LongInt;
Var
  h, m, s, hs : Word;
begin
  DecodeTime( SysUtils.Time, h, m, s, hs);
  time := Longint(Longint(h)*60*60*100) + Longint(Longint(m)*60*100) + (s*100) + hs;
end;

Function TimeLapst(var tL  : LongInt; timeL : LongInt) : Boolean;
var
  t : Longint;
begin
  t := Trunc(time / 100);
  if ((t - tl) >= timeL) or (tL = 0) then
   begin
     tl := t;
     TimeLapst := True;
   end
  else TimeLapst := False
end;
{************************ End of Time routine ********************}

function Test(f : string) :Boolean;
var
  DirInfo: TSearchRec;
begin
  Test := True; {$WARNINGS OFF}
   if FindFirst(f , faArchive, DirInfo) <> 0 then Test := False;{$WARNINGS ON}
  FindClose(DirInfo);
end;

Function TestOpen(f : String):Boolean;
var
  f2 : File;
Label  l1;
begin
   if FileExists(f) then
    begin
      TestOpen := true;
    end
    else begin
      {$I-}
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
      {$I-}
      TestOpen := (IOResult = 0) and (f <> '');
    end;
end;

Function Open(f : String):Word;
var
  f2 : File;
Label  l1;
begin
   if FileExists(f) then
    begin
      Open := 0;
    end
    else begin
      {$I-}
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
      {$I-}
      Open := IOResult;
    end;
end;

{Function CToFileDir(FileName : ComStr) : DirStr;
var
  P: PathStr;
  D,te : DirStr;
  N: NameStr;
  E: ExtStr;
begin
  GetDir(0,te);
  CToFileDir := te;
  FSplit(FileName, D, N, E);
   while d[Length(d)] = '\' do Dec(d[0]);
   if d <> '' then ChDir(D);
end;}

Function DeleteFile(f:ComStr):Word;
var
  f2 : File;
begin
  result := 0;
{$I+}
   if FileExists(f) then
    begin
      AssignFile(f2, f);
      try
	Reset(f2);
	CloseFile(f2);
	Erase(f2);
      except
	on E: EInOutError do result := E.ErrorCode;
      end;
    end;
end;

Function CreateFile(f:ComStr):Word;
begin
   if test(f)then result := 0
   else if TestDir(f) then result := Open(f)
   else if InString(f,':') and not DriveExists(f) then result := 15
    else begin
      result := CreateDir(f);
       if result = 0 then result := Open(f);
    end
end;

Function CreateDir(f:ComStr):Word;
//leave a trailing \ if the hole string is a drectory
var
  f1: string;
begin
  f:= FilePath(f);
   If TestDir(f) then result := 0
    else begin
       if InString(f,':') and not DriveExists(f) then result := 15
	else  begin
	  f1 := '';
	  while f <> '' do
	    begin
	      f1 := f1 + splitK3(f,'\') + '\';
	       if not TestDir(f1) then MDir(f1);
	       if not TestDir(f1) then begin result := 601; exit end;
	    end;
	  Result := 0;
	end;
    end;
end;

Function TestDir(name: ComStr):Boolean;
var
  temp:	ComStr;
begin
  GetDir(0,temp);
{$I-}
  name := DelTrailing(name, '\');
ChDir(name);
 if IOResult <> 0 then TestDir := False
 else result := True;
{$I+}
  ChDir(temp);
end;
{************************ Start of InOut error routine ********************}
Procedure TraceError(u : UnitET; line : Word);
begin
   if TraceSP = TraceStackSize then
    begin
      TraceStack[TraceSP].u := u;
      TraceStack[TraceSP].line := line;
    end
    else begin
      inc(TraceSP);
      TraceStack[TraceSP].u := u;
      TraceStack[TraceSP].line := line;
   end;
end;

Function InOutError : Boolean; Assembler; {$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	lockIO, 0
  je	@s1
  sub	al, al
  jmp	@end
@s1:
  mov	al, InOutError2
@end:
end;

Function GetLastInOutError: Word; Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  mov	ax, InOutErrorCode
end;

Procedure RunError(e : Word);
begin
   System.RunError(e);
end;

Function TestInOutError : Boolean; Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	lockIO, 0
  je	@s1
  sub	al, al
  jmp	@end
@s1:	mov	ax, TraceSP
	cmp	ax, 0
	je	@s2
	mov	TraceSPOld, ax
	xor	ax, ax
	mov	TraceSP, ax
@s2:	xchg 	al, InOutError1
@end:
end;

Procedure InOut(in1, unit1, line : Word); Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	lockIO, 0
  jne	@End
  mov	InOutError2, 0
  cmp	InOutError1, 0
  jne	@Error
  cmp	in1, 0
  je	@end
  jmp	@SetError
@Error:
  push	InOutErrorCode
  call	RunError
  jmp	@end
@SetError:
  cmp	InOutError1, 0
  jne	@Error
  mov	ax, unit1
  mov	errorInUnit, ax
  mov   ax, line
  mov	errorLine, ax
  mov	ax, in1
  mov	InOutErrorCode, ax
  mov	InOutError1, 1
  mov	InOutError2, 1
  cmp   InOutProc.word(0), 0
  jne	@CallProc
  cmp	InOutProc.word(2), 0
  je	@end
@CallProc:
  call	InOutProc
  mov	InOutError2, 1
@end:
end;

Procedure InOutAsm; Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	lockIO, 0
  jne	@End
  mov   InOutError1, 0
  cmp	InOutError1, 0
  jne	@Error
  cmp	ax, 0
  je	@end
  jmp	@SetError
@Error:
  push	InOutErrorCode
  call	RunError
  jmp	@end
@SetError:
  cmp	InOutError1, 0
  jne	@Error
  mov	InOutErrorCode, ax
  mov	InOutError1, 1
  mov	InOutError2, 1
  cmp   InOutProc.word(0), 0
  jne	@CallProc
  cmp	InOutProc.word(2), 0
  je	@end
@CallProc:
  call	InOutProc
  mov	InOutError2, 1
@end:
end;

Procedure InOutErrorAsm; Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	InOutError2, 0
end;

Procedure InOutZ; Assembler;{$WARNINGS OFF}
asm{$WARNINGS ON}
  cmp	lockIO, 0
  jne	@End
  mov	InOutError2, 0
  cmp	InOutError1, 0
  je	@s1
  push	InOutErrorCode
  call	RunError
@s1:
  mov	InOutErrorCode, 0
@end:
end;


Procedure WriteTrace;
var
  x	:Word;
begin
  Write(InOutErrorCode);
   for x := 1 to TraceSP do
    begin
      WriteLn(Byte(TraceStack[TraceSP].u));
      WriteLn(TraceStack[TraceSP].line);
    end
end;
{************************ End of InOut error routine ********************}
BEGIN
  TraceSP := 0;

  InOutProc := nil
//  InOutProc.word(2), 0
END.
