unit _GetUser;
{$WARN UNSAFE_TYPE OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ConstDef;

type
  TLoginForm = class(TForm)
    Name: TEdit;
    Pasword: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ok: TBitBtn;
    BitBtn2: TBitBtn;
    UsersList: TComboBox;
    procedure OkClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure PaswordEnter(Sender: TObject);
    procedure PaswordExit(Sender: TObject);
    procedure NameEnter(Sender: TObject);
    procedure NameKeyPress(Sender: TObject; var Key: Char);
    procedure UsersListChange(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LoginForm: TLoginForm;
procedure Login(var user, pasword: string);
procedure InputPaswords(var pasword1, pasword2: string);
implementation
Uses _Buffers, _dos;
{$R *.DFM}

procedure InputPaswords(var pasword1, pasword2: string);
begin
  //LoginForm.Name.SetFocus;
  LoginForm.UsersList.Visible := False;
  LoginForm.Name.Visible := True;

  LoginForm.Name.PasswordChar := '*';
  LoginForm.Name.Text := '';
  LoginForm.pasword.Text := '';
  LoginForm.label3.Caption := 'Confirm password';
  LoginForm.Label2.Caption := 'Password';
  LoginForm.Label1.Caption := 'Enter new password twice';
  LoginForm.Caption := 'Passwords';
  LoginForm.ShowModal;
  pasword1 := LoginForm.Name.Text;
  Pasword2 := LoginForm.pasword.Text;
  LoginForm.Name.PasswordChar := #0;
  LoginForm.Name.Text := '';
  LoginForm.pasword.Text := '';
  LoginForm.Label2.Caption := 'Name';
  LoginForm.label3.Caption := '        Password';
  LoginForm.Label1.Caption := 'Enter user name and password';
  LoginForm.Caption := 'Login';
end;

procedure Login(var user, pasword: string);
begin
  LoginForm.UsersList.Visible := True;
  LoginForm.Name.Visible := False;
  LoginForm.pasword.Text := '';
  if mrCancel = LoginForm.ShowModal then
    begin
      User := 'No user';
      Pasword := '';
    end
    else begin
      User := LoginForm.UsersList.Text;
      Pasword := LoginForm.pasword.Text;
    end;
end;

procedure TLoginForm.OkClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TLoginForm.CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TLoginForm.PaswordEnter(Sender: TObject);
begin
  Ok.Default := True;
end;

procedure TLoginForm.PaswordExit(Sender: TObject);
begin
    Ok.Default := False;
end;

procedure TLoginForm.NameEnter(Sender: TObject);
var
  x:word;
  buf: BufferO;
  f:String;
begin
  buf := BufferO.Create;
  f := ProgramDir + 'LastUser.Jsy';
   if test(f) then
    begin
       if LoadBuffer(buf, f) = 0 then UsersList.Text := buf.Get(1)
       else UsersList.Text := DefaultUser;
    end
    else UsersList.Text := DefaultUser;
   if UsersList.Visible then UsersList.SetFocus;
   if Name.Visible then Name.SetFocus;
  UsersList.Items.Clear;
   for x := 0 to pas.NumOfUsers - 1 do
    UsersList.Items.Append(pas.GetUserNameX(x+1));
  buf.Destroy;
end;

procedure TLoginForm.NameKeyPress(Sender: TObject; var Key: Char);
begin
   if key = #13 then
    begin
      key := #0;
      if Pasword.Enabled then Pasword.SetFocus;
    end;
end;

procedure TLoginForm.UsersListChange(Sender: TObject);
begin
  Name.Text := UsersList.Text;
   if UsersList.ItemIndex <> -1 then
    begin
      if Pasword.Enabled
      and (UsersList.Text = UsersList.Items[UsersList.ItemIndex])
      then Pasword.SetFocus;
    end;
end;

procedure TLoginForm.FormHide(Sender: TObject);
Var
  f:String;
  buf:BufferO;
begin
  buf := BufferO.Create;
  f := ProgramDir + 'LastUser.Jsy';
  buf.Ovr(UsersList.Text,1);
  SaveBuffer(buf, f);
  buf.Destroy;
end;

End.
