{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W+,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit _openFile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons;


type
  TOpenFileForm = class(TForm)
    ListView1: TListView;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TreeViewDir: TTreeView;
    BitBtn3: TBitBtn;
    StatusBar1: TStatusBar;
    procedure OpenClick(Sender: TObject);
    procedure CancalClick(Sender: TObject);
    procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure TreeViewDirChange(Sender: TObject; Node: TTreeNode);
  private
     OldSubDir:string;
    { Private declarations }
  public
    { Public declarations }
  end;

  Procedure OpenSplFile;

var
  OpenFileForm: TOpenFileForm;

implementation
uses
  ConstDef, _Code, _String, _Dos, _LoadTree;
var
//  oldsubdir :String;
  setUp:	Boolean;

{$R *.DFM}
Procedure LoadList; Forward;



Procedure OpenSplFile;
begin
  setUp := True;
  OpenFileForm.OldSubDir := subdir;
  LoadList;
  LoadTree(OpenFileForm.TreeViewDir, RootDir, SubDir);
  setUp := False;
   if OpenFileForm.ShowModal <> mrOk then subDir := OpenFileForm.OldSubDir;
end;

Procedure LoadList;
var
SearchRec:	TSearchRec;
found:		Integer;
ListItem:	TListItem;
begin
   OpenFileForm.ListView1.Visible := false;
 //  while OpenFileForm.ListView1.Items.Count > 0 do
     OpenFileForm.ListView1.Items.Clear;// .Delete(OpenFileForm.ListView1.Items.Count - 1);
    Found := FindFirst(RootDir+SubDir+'*.spl', faDirectory, SearchRec);
    while Found = 0 do
    begin
       if SearchRec.Attr <> faDirectory then
	begin
	  ListItem := OpenFileForm.ListView1.Items.Add;
	  ListItem.Caption := SearchRec.Name;
	  ListItem.SubItems.Add(IntToStr(FileSizeText(RootDir+SubDir+SearchRec.Name)));
	   if SearchRec.Attr = faDirectory then ListItem.SubItems.Add('Dir')
	   else ListItem.SubItems.Add('File');
	end;
      Found := FindNext(SearchRec);
    end;
  FindClose(SearchRec);
  OpenFileForm.Label1.Caption := SubDir + CurrentFile;
  OpenFileForm.ListView1.Visible := True;

end;

procedure TOpenFileForm.OpenClick(Sender: TObject);
begin
  if ListView1.SelCount > 0 then
  begin
   if ListView1.Selected.SubItems[0] = 'Dir' then
    begin
       if not SetCurrentDir(RootDir+SubDir+ListView1.Selected.Caption) then
	begin
	  MessageDlg(' Error Changing Dir'+ ErrorCode(0),mtError, [mbOk], 0)
	end
	else begin
	  SubDir := SubDir + ListView1.Selected.Caption+'\';
	  LoadList;
	end;
    end
    else begin
      CurrentFile := ListView1.Selected.Caption;
      OpenFileForm.ModalResult := 1;
    end;
  end;

end;

procedure TOpenFileForm.CancalClick(Sender: TObject);
begin
  SubDir := oldSubDir;
  OpenFileForm.ModalResult := 1;
end;

procedure TOpenFileForm.ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
				  Data: Integer; var Compare: Integer);
begin
   if item1.SubItems.Count <= 0 then Compare := -1
   else if item2.SubItems.Count <= 0 then Compare := 1
   else if (item1.SubItems.Count > 0) and (item2.SubItems.Count > 0) then
    begin
      if      item1.SubItems.Strings[0] > item2.SubItems.Strings[0] then Compare := 1
      else if item1.SubItems.Strings[0] < item2.SubItems.Strings[0] then Compare := -1
      else if item1.Caption 		> item2.Caption then		 Compare := 1
      else if item1.Caption 		< item2.Caption then		 Compare := -1
      else Compare := 0;
    end
   else begin
     if item1.Caption > item2.Caption then Compare := 1
     else if item1.Caption < item2.Caption then Compare := -1
     else Compare := 0;
   end;
end;

procedure TOpenFileForm.TreeViewDirChange(Sender: TObject;
  Node: TTreeNode);
var
  tempnode:TTreeNode;
  s:string;
begin
//  tempNode := node;
  If setUp then Exit;
  tempNode := TreeViewDir.Selected;
   if (tempNode <> nil) then
    begin
      x := tempNode.Level;
      s := '';
       while x >= 1 do
	begin
	   if s = '' then s := tempNode.Text+'\'
	   else s := tempNode.Text+'\'+s;
	  tempNode := tempNode.Parent;
	  x := tempNode.Level;
	end;
      if s <> SubDir then
       begin
	 subDir := s;
	 LoadList;
       end;
    end;
end;

end.
