{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U+,V+,W+,X+,Y+,Z1}
{$APPTYPE GUI}
unit _RegKey;

interface


Function GetRegKey(regKeyOffset,key:String):String;
Function GetRegKeyBool(regKeyOffset, key:String):Boolean;
//defaults to false.
Function GetRegKeyBool2(regKeyOffset, key:String):Boolean;
// befaults to true.

procedure WriteKeyBool(regKeyOffset, key: String; val: Boolean);
procedure WriteKey(regKeyOffset, key, val: String);

function RegKeyExists(regKeyOffset,key:String):Boolean;

implementation
uses
  registry, windows;

function RegKeyExists(regKeyOffset,key:String):Boolean;
var
  Reg: TRegistry;
begin
  result := False;
  Reg := TRegistry.Create;
  try
    Reg.RootKey :=  HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(regKeyOffset, False)
    then result := Reg.ValueExists(key);
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;


Function GetRegKey(regKeyOffset,key:String):String;
var
  Reg: TRegistry;
begin
  result := '';
  Reg := TRegistry.Create;
  try
    Reg.RootKey :=  HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(regKeyOffset, False)
    then result := Reg.ReadString(key);
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

Function GetRegKeyInt(regKeyOffset,key:String):Integer;
var
  Reg: TRegistry;
begin   //                          word
  result := 0;
  Reg := TRegistry.Create;
  try
    Reg.RootKey :=  HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(regKeyOffset, False)
    then result := Reg.ReadInteger(key);
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

Function GetRegKeyBool2(regKeyOffset, key:String):Boolean;
// befaults to true;
var
  Reg: TRegistry;
begin
  result := True;
  Reg := TRegistry.Create;
  try
    Reg.RootKey :=  HKEY_LOCAL_MACHINE;
    if (Reg.OpenKey(regKeyOffset, False))
      and (Reg.GetDataType(key) = rdInteger)
      then result := Reg.ReadBool(key);
  finally
    Reg.CloseKey;
    Reg.Free
  end;
end;

Function GetRegKeyBool(regKeyOffset, key:String):Boolean;
var
  Reg: TRegistry;
begin
  result := False;
  Reg := TRegistry.Create;
  try
    Reg.RootKey :=  HKEY_LOCAL_MACHINE;
    if (Reg.OpenKey(regKeyOffset, False))
      and (Reg.GetDataType(key) = rdInteger)
      then result := Reg.ReadBool(key);
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

procedure WriteKeyBool(regKeyOffset, key: String; val: Boolean);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(regKeyOffset, True)
    then Reg.WriteBool(key, val);
  finally
    Reg.CloseKey;
    Reg.Free;
//    inherited;
  end;
end;


procedure WriteKey(regKeyOffset, key, val: String);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(regKeyOffset, True)
    then Reg.WriteString(key, val);
  finally
    Reg.CloseKey;
    Reg.Free;
//    inherited;
  end;
end;

end.
