unit _ScoreUtils2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IBDatabase, Db, IBCustomDataSet, IBTable, _String, _Buffers, _Score,
  Grids, DBGrids, _SqlUtills, _Dos, IBSQL, ConstDef, IBQuery, StdCtrls,
  ComCtrls, Buttons, registry, IBStoredProc;

type
  scoreR = record
	     name: String;
	     score: Integer;
	     maxHelp,
	     tolalHelp,
	     total	:word;
	   end;

type
  TSU = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    IBQuery1: TIBQuery;
    IBDataSet1: TIBDataSet;
    GroupBox1: TGroupBox;
    ShowWrongWords: TCheckBox;
    ShowRightWords: TCheckBox;
    ShowCurrentUser: TRadioButton;
    PickFromList: TRadioButton;
    ShowAllUser: TRadioButton;
    UserList: TComboBox;
    FromTime: TDateTimePicker;
    Label1: TLabel;
    FromDate: TDateTimePicker;
    ToDate: TDateTimePicker;
    Label2: TLabel;
    updateBtn: TBitBtn;
    RowCount: TLabel;
    Label3: TLabel;
    OpenScoreFile: TOpenDialog;
    SQL: TMemo;
    StatusBar1: TStatusBar;
    Count1: TCheckBox;
    IBStoredProc1: TIBStoredProc;
    DBName: TLabel;
    procedure updateBtnClick(Sender: TObject);
    procedure updateUserList(Sender: TObject);
    procedure ShowCurrentUserClick(Sender: TObject);
    procedure ShowAllUserClick(Sender: TObject);
    procedure PickFromListClick(Sender: TObject);
    procedure FromDateClick(Sender: TObject);
    procedure FromTimeChange(Sender: TObject);
    procedure ToDateChange(Sender: TObject);
    procedure UserListChange(Sender: TObject);
    procedure ShowRightWordsClick(Sender: TObject);
    procedure ShowWrongWordsClick(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    Procedure ConectDB;
    procedure Count2Click(Sender: TObject);
    procedure ToDateClick(Sender: TObject);
    function CreateSql():String; virtual;
  protected
    Function UpDateSQL():String ;
  private
    { Private declarations }
      EIBErrorCode: Integer;
      ESQLCode: Integer;
      EMessage: String;
//    Function ConectToDB:Boolean;
    Function ConectToDB:Boolean;

  public
    function GetNextLogGroup:Integer;
    Procedure ChangeDB;
    { Public declarations }
  end;

var
  SU: TSU;
//procedure loadBufFromScoreDB(f: String; hiLight:Boolean);
procedure AddScore(f:String;r:scoreR; logGroup:word);
procedure AddLog(name, f, Word, answer:String; logGroup, helpCount: word);

implementation
uses _RegKey, IB;
{$R *.DFM}

procedure AddLog(name, f, Word, answer:String; logGroup, helpCount: word);
var
  s1,s2:	String;
begin
  SU.ConectDB;
   if word = answer then s1 := 'INSERT INTO log '+
	'(name, date1, time1, file1, word, log_Group, help_count)'+
	' VALUES ('
   else s1 := 'INSERT INTO log '+
	'(name, date1, time1, file1, word, log_Group, help_count, answer)'+
	' VALUES (';
  s2:='';
  AddSqlString(s2, name);
  AddSqlString(s2, GetDateS);
  AddSqlString(s2, GetTimeS);
  AddSqlString(s2, SubDir + FileName(f));
  AddSqlString(s2, word);
  s2 := s2 + ', ' + IntToStr(logGroup);
  s2 := s2 + ', ' + IntToStr(helpCount);
  if word <> answer then AddSqlString(s2, answer);
  s2 := s2 + ')';
  s1 := s1+s2;
  su.IBQuery1.SQL.Clear;
  su.IBQuery1.SQL.Add(s1);
  su.IBQuery1.ExecSQL;
   if su.IBTransaction1.InTransaction then
      su.IBTransaction1.CommitRetaining;
end;

procedure AddScore(f:String;r:scoreR; logGroup:word);
var
  s1,s2:	String;
begin
  SU.ConectDB;
  s1 := 'INSERT INTO score '+
   '(name, date1, time1, file1, max_help,  help_total, word_count, score,'+
   'log_group  ) VALUES (';
  s2:='';
  AddSqlString(s2, r.name);
  AddSqlString(s2, GetDateS);
  AddSqlString(s2, GetTimeS);
  AddSqlString(s2, SubDir + FileName(f)+'.SCO');
  s2 := s2 + ',' + IntToStr(r.maxHelp)+
	','+IntToStr(r.tolalHelp)+
	','+IntToStr(r.total)+
	','+IntToStr(r.score)+
	','+intToStr(logGroup)+')';

  s1 := s1+s2;
  su.IBQuery1.SQL.Clear;
  su.IBQuery1.SQL.Add(s1);
  su.IBQuery1.ExecSQL;
   if su.IBTransaction1.InTransaction then
      su.IBTransaction1.CommitRetaining;
end;

(*procedure loadBufFromScoreDB(f: String; hiLight:Boolean);
//f should be subdir + file
var
  buf:BufferO;
  percentS, nameS, dateS, timeS, maxHelpS, totalS,
  scoreS, s1, file1:string;
  totalN, scoreN, percent, maxHelp, totalHelp :integer;
begin
  SU.ConectDB;
  buf.Init;
  s1 := 'select * from score where UPPER(file1) = '#39+SUpCase(f)+#39' ORDER BY scoreid DESC';
  su.IBQuery1.Close;
  su.IBQuery1.SQL.Clear;
  su.IBQuery1.SQL.Add(s1);
  su.IBQuery1.Prepare;
  su.IBQuery1.Open;
  s1:='';
  su.IBQuery1.First;
   if not su.IBQuery1.Eof then
    begin
      repeat
	// := su.IBTable1.FieldByName('help_total');
	file1 := su.IBQuery1.FieldByName('file1').AsString;
	nameS := su.IBQuery1.FieldByName('name').AsString;
	dateS := su.IBQuery1.FieldByName('date1').AsString;
	timeS := su.IBQuery1.FieldByName('time1').AsString;
	maxHelp := (su.IBQuery1.FieldByName('max_help').AsInteger);
	totalS:= IntToStr(su.IBQuery1.FieldByName('word_count').AsInteger);
	scoreS:= IntToStr(su.IBQuery1.FieldByName('score').AsInteger);
	totalHelp := (su.IBQuery1.FieldByName('HELP_TOTAL').AsInteger);
	totalN := StrToNum(totalS);
	scoreN := StrToNum(scoreS);
	 if totalHelp = 1 then scoreN := scoreN -1;
	scoreN := scoreN - (maxHelp div 2) - (totalHelp div 3);
	 if totalN = 0 then totalN := 1;
	 if scoreN <= 0 then percent := 0
	 else percent := round((100 / totalN) * scoreN);
	nameS := PadTo(nameS, '', 51);
	 if dateS <> '' then dateS := ' on the ' + dateS;
	dateS := PadTo(dateS, #46, 18);
	 if timeS <> '' then timeS := '@'+timeS;
	maxHelpS := ' '+PadTo(maxHelpS, ' ', 3)+' ';
	timeS := PadTo(timeS, #46, 9);
	percentS := PadFront(IntToStr(percent),'0',3);
	scoreS := PadFront(scoreS,' ',3);
	totalS := PadTo(totalS,' ',3);
	s1 := nameS+'%'+percentS+' or '+scoreS+'/'+totalS+
	      dateS+timeS;
	buf.add(s1);
	su.IBQuery1.Next;
      until su.IBQuery1.Eof;
      if hiLight then buf.Ovr('*' + buf.Get(1), 1);
    end;
  ShowScore(buf);
  buf.Done;
end;*)


(*procedure loadBufFromLogDB(f: String; hiLight:Boolean);
//f should be subdir + file
var
  buf:BufferO;
  wordS, nameS, dateS, timeS, answerS
  , s1, file1:string;
//  totalN, scoreN, percent:integer;
begin
  SU.ConectDB;
  buf.Init;
  s1 := 'select * from log where UPPER(name) = '#39+SUpCase(pas.user)+#39' ORDER BY logId DESC';
  su.IBQuery1.Close;
  su.IBQuery1.SQL.Clear;
  su.IBQuery1.SQL.Add(s1);
  su.IBQuery1.Prepare;
  su.IBQuery1.Open;
  s1:='';
  su.IBQuery1.First;
   if not su.IBQuery1.Eof then
    begin
      repeat
	// := su.IBTable1.FieldByName('help_total');
	file1 := su.IBQuery1.FieldByName('file1').AsString;
	nameS := su.IBQuery1.FieldByName('name').AsString;
	dateS := su.IBQuery1.FieldByName('date1').AsString;
	timeS := su.IBQuery1.FieldByName('time1').AsString;
	wordS := su.IBQuery1.FieldByName('word').AsString;
	answerS := su.IBQuery1.FieldByName('answer').AsString;
	s1 := nameS+' '+file1+' '+dateS+' '+timeS+' '+
	      wordS+' '+answerS;
	buf.add(s1);
	su.IBQuery1.Next;
      until su.IBQuery1.Eof;
      if hiLight then buf.Ovr('*' + buf.Get(1), 1);
    end;
  ShowScore(buf);
  buf.Done;
end;*)

procedure TSU.updateUserList(Sender: TObject);
var
  x:word;
//  buf: BufferO;
//  f:String;
begin
//  UserList.Text := pas.User;
  UserList.Items.Clear;
   for x := 0 to pas.NumOfUsers - 1 do
    UserList.Items.Append(pas.GetUserNameX(x+1));
  UserList.ItemIndex := UserList.Items.IndexOf(pas.User);
  FromDate.Date := Now - 7;
  ToDate.Date := Now;
  UpDateSQL;
  updateBtnClick(sender);
end;

function tsu.CreateSql():String ;
var
  sql, name, s2:	String;
  whereAdded:	Boolean;
begin
  if Count1.Checked then
    sql := ' select word, count(word) from log '
  else sql := ' select * from log ';
//add sql for showing right and wrong answers
  whereAdded := True;
   if ShowRightWords.Checked
    and not ShowWrongWords.Checked
    then sql := sql + ' where ANSWER IS NULL '
   else if not ShowRightWords.Checked
    and ShowWrongWords.Checked
    then sql := sql + ' where ANSWER IS NOT NULL '
   else if ShowRightWords.Checked
    and ShowWrongWords.Checked
    then whereAdded := False //sql := sql + 'where ANSWER IS NOT NULL'
   else if not ShowRightWords.Checked
    and not ShowWrongWords.Checked
    then sql := sql + ' where ANSWER <> ANSWER ';
// add sql for whitch user to show
   if ShowCurrentUser.Checked then
    begin
      name := pas.User;
      if name = '' then
	begin
	  ShowMessage('No valid user name');
	  ModalResult := mrCancel;
	  result := '';
	end;
    end
   else if PickFromList.Checked then name := UserList.Text
   else name := '';
   if name <> '' then
    begin
       if whereAdded then sql := sql + ' and name = '
       else sql := sql + ' where name = ';
      AddSqlQuote(sql, name);
      whereAdded := True;
    end;
//date checking code.
   if FromDate.Checked then
    begin
      name := '';
      s2 := '';
      AddSqlQuote(name, UnCodeDate(FromDate.Date - 1));
      AddSqlQuote(s2, UnCodeDate(ToDate.Date));
       if whereAdded then
	begin
	  sql := sql + ' and cdate(date1,'+ name + ') = 1 ';
	  if ToDate.Checked then
	    sql := sql + ' and cdate(date1,'+ s2 + ') <> 1 ';
	end
	else begin
	  sql := sql + ' where cdate(date1,'+ name + ') = 1 ';
	  if ToDate.Checked then
	    sql := sql + ' and cdate(date1,'+ s2 + ') <> 1 ';
	end;
    end;
  if Count1.Checked then
    sql := sql + ' group by word order by 2 desc';
  result := sql;
end;

Function TSU.UpDateSQL():String ;
begin
  SQL.Text := self.CreateSql;
end;

procedure TSU.updateBtnClick(Sender: TObject);
var
  sql:	String;
  col:	TColumn;
  x:	Word;
begin
//   if (not su.Visible) or (su.SQL.Lines[1] = 'No SQL') then UpDateSQL;
  sql := self.SQL.Text;
  ConectDB;
  IBDataSet1.Active := False;
  IBDataSet1.SelectSQL.Text := sql;
  IBDataSet1.Active := True;
  DBname.Caption := 'Database name:'+IBDatabase1.DatabaseName;
  if IBDataSet1.RecordCount > 0 then IBDataSet1.Last;
   if (sql <> self.CreateSql) or (Count1.Checked) then
    begin
      DBGrid1.Columns.RebuildColumns;
      for x := 0 to DBGrid1.Columns.Count - 1 do
	if DBGrid1.Columns[x].Width > 150 then
	  DBGrid1.Columns[x].Width := 150;
    end
   else
    begin
      DBGrid1.Columns.Clear;
      col := DBGrid1.Columns.Add;
      col.Width := 100;
      col.FieldName := 'NAME';
      col := DBGrid1.Columns.Add;
      col.Width := 150;
      col.FieldName := 'WORD';
      col := DBGrid1.Columns.Add;
      col.Width := 150;
      col.FieldName := 'ANSWER';
      col := DBGrid1.Columns.Add;
      col.Width := 55;
      col.FieldName := 'TIME1';
      col.Title.Caption := 'Time';
      col := DBGrid1.Columns.Add;
      col.Width := 70;
      col.FieldName := 'DATE1';
      col.Title.Caption := 'Date';
      col := DBGrid1.Columns.Add;
      col.Width := 175;
      col.FieldName := 'FILE1';
      col.Title.Caption := 'File';
      col := DBGrid1.Columns.Add;
      col.Width := 30;
      col.FieldName := 'HELP_COUNT';
      col.Title.Caption := 'Help';
     end;
  RowCount.Caption := IntToStr( DBGrid1.DataSource.DataSet.RecordCount);
end;

{$O-}
Function TSU.ConectToDB:boolean;
var
  dbName:	String;
//  t:            TIBDataBaseErrorMessages;
begin
  dbName := GetRegKey(regKeyOffset, DBKey);
   if dbName = '' then
    begin
      OpenScoreFile.FileName := DefaultDB;
      OpenScoreFile.Execute;
      dbName := OpenScoreFile.FileName;
      WriteKey(regKeyOffset, 'scoreDB',dbName);
    end;
  try
    IBDatabase1.DatabaseName := dbName;
    if not IBDatabase1.Connected then IBDatabase1.Connected := True;
    if not IBTransaction1.Active then IBTransaction1.Active := True;
    DataSource1.AutoEdit := True;
    Result := True;
  except
    on E: EIBInterBaseError do
    begin
      result :=false;
      EIBErrorCode:= E.IBErrorCode;
      ESQLCode:=E.SQLCode;
      EMessage:=E.Message;
      ShowMessage(intToStr(E.IBErrorCode)+IntToStr(E.SQLCode)+E.Message);
//      if E.IBErrorCode = 335544375 then Raise //db not runing
//      else if E.IBErrorCode = 335544376 then Raise;
//	if E.IBErrorCode = ord(ibxeInterBaseMissing) then result := false;
//	else Raise;
    end;
  else
      Result := False;
  end;
end;
{$O+}

Procedure TSU.ChangeDB;
var
  dbName:string;
begin
  if pas.PasLevel < ChangeDBPasLev
    then MessageDlg('Access denied',  mtWarning, [mbOK],0)
  else begin
    dbName := GetRegKey(regKeyOffset, 'scoreDB');
    if dbName = '' then dbName := ProgramDir +'scoreDB.gdb';
    OpenScoreFile.InitialDir := FilePath(dbName);
    OpenScoreFile.FileName := FileNameExt(dbName);

    if OpenScoreFile.Execute then
    begin
      dbName := OpenScoreFile.FileName;
      dbName := InputBox('Data base', 'Edit if wrong:', dbName);
      WriteKey(regKeyOffset, 'scoreDB', dbName);
      IBDatabase1.Connected := False;
      ConectDB;
    end;
  end;
end;

Procedure TSU.ConectDB;
procedure bale(s:String);
begin
  if MessageDlg('Database file:'+GetRegKey(regKeyOffset, 'scoreDB')+#10+
       s+#10 +
       'do you whant to try again click No to exit Spl6?',
       mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
  begin
    closeButton := True;
    Application.Terminate;
    Exit;
  end;
end;

var
  con:boolean;
begin
  if IBDatabase1.Connected then Exit;
  repeat
    con := ConectToDB;
    if con = false then
    begin
      if EIBErrorCode = 335544375 then //db not runing
	Bale('Cannot connect to the database engine. Are you sure firebird or another interbase compatible database is running? ')
      else begin
	if EIBErrorCode = 335544323 then Bale('The current database file is not a valid database file please click yes to choose a new one.')//not a database file.
	else Bale('Can not open the database file for spl');
	ChangeDB;
      end;
//	  else if E.IBErrorCode = 335544376 then Raise;

    end;
  until con or closeButton;
end;

procedure TSU.ShowCurrentUserClick(Sender: TObject);
begin
  UserList.Enabled := False;
  UpDateSql;
end;

procedure TSU.ShowAllUserClick(Sender: TObject);
begin
  UserList.Enabled := False;
  UpDateSql;
end;

procedure TSU.PickFromListClick(Sender: TObject);
begin
  UserList.Enabled := True;
  UpDateSql;
end;

procedure TSU.FromDateClick(Sender: TObject);
begin
  if FromDate.Checked = true then
    Begin
      FromDate.Color := clGreen;
      FromDate.Font.Color := clBlack;
      ToDate.Enabled := True;
    end
  else
    begin
      FromDate.Color := clWindow;
      FromDate.Font.Color := clWindowText;
      ToDate.Enabled := False;
    end;
  UpDateSql;
end;

procedure TSU.FromTimeChange(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU.ToDateChange(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU.UserListChange(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU.ShowRightWordsClick(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU.ShowWrongWordsClick(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU.DBGrid1CellClick(Column: TColumn);
begin
  DBGrid1.Hint := DBGrid1.SelectedField.Text;
end;

procedure TSU.Count2Click(Sender: TObject);
begin
  if Visible then UpDateSql;
end;

procedure TSU.ToDateClick(Sender: TObject);
begin
    if ToDate.Checked = true then
    Begin
      ToDate.Color := clGreen;
      ToDate.Font.Color := clBlack;
    end
  else
    begin
      ToDate.Color := clWindow;
      ToDate.Font.Color := clWindowText;
    end;
  UpDateSql;
end;

function TSU.GetNextLogGroup:Integer;
begin
  ConectDB;
  IBStoredProc1.Prepare;
  IBStoredProc1.ExecProc;
  result := IBStoredProc1.Params.Items[0].AsInteger;
end;

end.
