{$A-,B-,D+,E+,F-,G-,I+,L+,N+,O-,R-,S-,V-,X+}
{$M 16384,0,655360}
unit _ExitData;
interface
Const
  DebugOff : Boolean = True;
implementation
uses Crt;
type
  HexFormat = String;
var
  ExitAddress : Pointer;
Function Hex(HexWord : Word): HexFormat;
Const
  HexDigits : Array[0..15] of Char = '0123456789ABCDEF';
begin
  Hex := '$' + HexDigits[hi(HexWord) div 16] +
	       HexDigits[hi(HexWord) mod 16] +
	       HexDigits[Lo(HexWord) div 16] +
	       HexDigits[Lo(HexWord) mod 16];
end;

Procedure WriteWord(wName : Word);
begin
  Write(Hex(wName), '           ');
  WriteLn(wName);
end;

Procedure WritePntr(pName : Pointer);
begin
  Write(Hex(Seg(pName)), ':',Hex(ofs(pName)));
  Write('     ');
  WriteLn(Seg(pName):5, ':',ofs(pName):5);
end;
{$F+}
Procedure TerminationData;
{$F-}
begin
  ExitProc := ExitAddress;
   If (ErrorAddr = nil) and (DebugOff) then Exit;
  Window(1, 1, 80, 25);
  ClrScr;
  write('Program segment prefix  '); WriteWord(PrefixSeg);
  write('Stack pointer low limit '); WriteWord(StackLimit);
  write('Overlay buffer origin   '); WriteWord(OvrHeapOrg);
  write('Overlay buffer pointer  '); WriteWord(OvrHeapPtr);
  write('Overlay buffer end      '); WriteWord(OvrHeapEnd);
  write('Heap origin             '); WritePntr(HeapOrg);
  write('Heap end                '); WritePntr(HeapEnd);
  write('Heap pointer            '); WritePntr(HeapPtr);
  write('Free heap list pointer  '); WritePntr(FreeList);
{  write('Minimum free list size  '); WriteWord(FreeMin);}
  write('Heap error function     '); WritePntr(HeapError);
  write('Exit procedure          '); WritePntr(ExitAddress); {!}
  write('Exit code               '); WriteLn(ExitCode);
  write('Runtime error address   '); WritePntr(ErrorAddr);
  write('Random seed             '); WriteLn(RandSeed);
  write('File open mode          '); WriteLn(FileMode);
  write('I/O result              '); WriteLn(InOutRes);
  write('8087 test result        '); WriteLn(Test8087);
  write('Code Segment            '); WriteWord(CSeg);
  write('Data Segment            '); WriteWord(DSeg);
  write('Stack Segment           '); WriteWord(SSeg);
  write('Stack pointer           '); WriteWord(SPtr);
  Write('Press any key ');
  While Not KeyPressed do ;
  ReadKey;
end;

BEGIN
  ExitAddress := ExitProc;
  ExitProc := @TerminationData;
END.