{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,R+,S+,V+,X-}
{$M 16384,0,655360}

Unit _JWord;

Interface

Uses _Buffers, dos, _Screen;
Const
  columns:		Byte = 1;
  endOfFileChar:	Char = ''; {#174}
  WordBufferAttr:	Byte = YellowC+BlueB;
  WordBufferBColor:	Byte = CyanB;

Type
  ListBufO = Object
	       Constructor Init;
	       Destructor Done;

	       Procedure WriteBuffer(var buf : BufferO; colWidth, shift : Byte; startPos : Word);
	       Function ListBuffer(
				 var
				   buf : BufferO;
				   caseS : Boolean) : String; Virtual;
	     end;

  WordBufferO = Object
		  buf:					BufferO;

		  Constructor Init;
		  Destructor Done;
		  {set unset wether to write ctrl Z on end of last line}
		  Procedure Edit(maxLineLength:	Byte);
		  Procedure Save;
		  Procedure SetCtrlZ;
		  Procedure UnSetCtrlZ;
		  Procedure WriteInfoTo(x,y: Word);
		  Function Install(f: ComStr):	Boolean; Virtual;
		  Function Updated:			Boolean;
		Private
		  infoToX, infoToY:			Word;
		  oldBColor, BColor, CAttr:		Byte;
		  name:					ComStr;
		  OldDir:				DirStr;
		  LinePos, ScreenPos, LineShift:	Integer;
		  Shift, bufShiftPos, oldFilePos:	Word;
		  oldLineShift:				Byte;
		  i, upD, saved, CtrlZ:			Boolean;
		  Procedure ClrScr;
		  Procedure DelLine;
		  Procedure InsLine;
		end;


IMPLEMENTATION

Uses Crt, _EditLine, _KeyB, _Dos, _Error, _String, _Win2, _Menus, _Code;

Procedure UpDateScreenShift(var screenShift : Word;pos, depth, columns : Word); ForWard;

var
  iTX, iTY:	Word;
  tempP:	Procedure;
  oldLL:	Word;
  lineInfo:	String[20];
{$F+}
Procedure WriteInfoP; {Assenbler;}
begin
  lineInfo := IntToStr(_EditLine.editFilePos)
	      +':'+IntToStr(_EditLine.linePos)
	      +':'+IntToStr(_EditLine.fileLength);
   if Length(lineInfo) < oldLL then lineInfo := PadTo(lineInfo, ' ', oldLL);
  DrectWriteS(iTX, iTY, 0, lineInfo);
  oldLL := Length(lineInfo);
  tempP
end;

{***************************Begin ListBufO****************************}
Procedure FNothing(var buf: BufferO;n : Word);
begin
end;
{$F-}


Constructor ListBufO.Init;
begin
end;

Destructor ListBufO.Done;
begin
end;

Function ListBufO.ListBuffer(var buf : BufferO; caseS : Boolean): String;
var
  x, screenShift, oldScrShift, lineShift, pos	: Word;
  Longst, maxLength, linePos, n, OldLineShift	: Word;
  cursorX, cursorY, cursorXOld, cursorYOld	: Byte;
  wW, wD					: Byte;
  k						: key;
begin
  linePos := 1;
  lineShift := 0;
  OldLineShift := 1;
  cursorX := 1;
  cursorY := 1;
  screenShift := 0;
  OldScrShift := 1;
  pos := 1;
  InOutZ;
  wW := WindWidth(0,0);
  wD := WindDepth(0,0);
   if wW < 1 Then InOut(531, 10, 84);
   if wD < 1 then InOut(532, 10, 85);
  Longst := 0;
   for x := 1 to buf.Len do if Length(buf.Get(x)) > Longst then Longst := Length(buf.Get(x));
  maxLength := Longst;
   if maxLength > wW then maxLength := wW;
    repeat
      cursorXOld := cursorX;
      cursorYOld := cursorY;
      cursorY := pos - screenShift;
      cursorX := 1;
       while cursorY > wD do
	begin
	  cursorY := cursorY - wD;
	  Inc(cursorX);
	end;
       cursorX := cursorX + ((cursorX - 1) * (maxLength));
       if (OldScrShift <> screenShift) or (OldLineShift <> lineShift) then
	begin
	  WriteBuffer(buf, maxLength + 1, lineShift, screenShift + 1);
	  OldScrShift := screenShift;
	  oldLineShift := lineShift;
	end
       else Bar(cursorXOld, cursorYOld, maxLength);
       Bar(cursorX, cursorY, maxLength);
       GotoXY(cursorX + (linePos - 1) - lineShift , cursorY);
      k := KeyLoop;
       if k = Left then
        begin
          linePos := 1;
           if pos > 1 then
            begin
	       if pos < wD then pos := 1
	       else pos := pos - wD;
	       if LongInt(screenShift) - wD < 0 then
	       screenShift := 0
	       else screenShift := screenShift - wD;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
        end
       else if k = Right then
        begin
          linePos := 1;
           if pos < buf.len then
            begin
	       if buf.len - pos   < wD then pos := buf.Len
	       else pos := pos + wD;
{?	      screenShift := screenShift + wD;}
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
        end
       else if k = up then
        begin
          linePos := 1;
           if pos > 1 then Dec(pos);
           if screenShift >= pos then Dec(screenShift);
        end
       else if k = Down then
        begin
          linePos := 1;
           if pos < Buf.len then Inc(pos);
	   if screenShift + (Columns * wD) <= pos then Inc(screenShift);
	end
       else if k = PgDn then
        begin
	  linePos := 1;
	   if pos < buf.Len then
	    begin
	       if pos + (wD * Columns - 1) <= buf.Len then
		begin
		  pos := Pos + (wD * Columns - 1);
		  screenShift := screenShift + (wD * Columns - 1);
		end
		else pos := buf.Len;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
	end
       else if k = PgUp then
        begin
	  linePos := 1;
	   if pos > 1 then
	    begin
	       if Longint(pos) - (wD * Columns - 1) >= 1 then
		begin
		  pos := LongInt(pos) - (wD * Columns - 1);
		   if LongInt(screenShift) - (wD * Columns - 1) < 0 then
		   screenShift := 0
		   else screenShift := LongInt(screenShift) - (wD * Columns - 1);
		end
		else pos := 1;
	      UpDateScreenShift(screenShift, pos, wD, Columns);
	    end;
	end
       else if k = Home then
        begin
          pos := 1;
          linePos := 1;
          screenShift := 0;
        end
       else if k = End1 then
        begin
          linePos := 1;
	  pos := buf.Len;
	  UpDateScreenShift(screenShift, pos, wD, Columns);
	end
       else if k = CLeft then
        begin
           if linePos > 1 then Dec(linePos);
        end
       else if k = CRight then
        begin
           if linePos < Length(buf.Get(pos)) then Inc(linePos);
	end
       else if (k = Enter) or (k = Esc) then
       else begin
	 n := buf.find(TruncateTo(buf.Get(pos), linePos - 1)+k[1], linePos, CaseS);
	  if n <> 0 then
	   begin
	     Inc(linePos);
	     pos := n;
	     UpDateScreenShift(screenShift, pos, wD, Columns);
	   end;
       end;
    Until (k = Enter) or (k = Esc) or (k = Ins);
   if not (k = Esc) then ListBuffer := buf.Get(pos)
   else ListBuffer := '';
end;

Procedure ListBufO.WriteBuffer(var buf : BufferO; colWidth, shift : Byte; startPos : Word);
Var
  x, y, wW, wD	: Byte;
  t 		: Word;
begin
  wW := WindWidth(0,0);
  wD := WindDepth(0,0);
   if colWidth < 1 then colWidth := 1;
   if colWidth > wW then colWidth := wW;
  columns := Trunc(wW / colWidth);
   ClrScr;
   for y := 1 to columns do
    begin
      t := (wD * (y - 1)) + (startPos - 1);
       for x := 1 to wD do
	begin
	   if x + t > buf.Len then Exit;
	  GotoXY(1 + ((y - 1) * (colWidth)), x);
	  Write(copy(buf.Get(x + t ), shift, colWidth) );
	end;
    end;
end;
{***************************End ListBufO****************************}

Procedure UpDateScreenShift(var screenShift : Word;pos, depth, columns : Word);
begin
  if screenShift < LongInt(pos) - (columns * WindDepth(0,0)) then
  screenShift := LongInt(pos) - (columns * WindDepth(0,0));
  if screenShift >= pos then screenShift := pos - 1;
end;

{*****************************Begin editBufferO****************************}
Var
  update : Boolean;

Constructor WordBufferO.Init;
begin
  BColor := WordBufferBColor;
  cAttr := WordBufferAttr;
  saved := True;
  buf.Init;
  i := False;
  upD := True;
  LinePos := 1;
  screenPos := 1;
  lineShift := 0;
  Shift := 0;
  bufShiftPos := 0;
  oldFilePos := 3;
  infoToX := 0;
  infoToY := 0;
  OldDir := GetDirCurrent;
  ctrlZ := False;
end;

Destructor WordBufferO.Done;
begin
  buf.Done;
  ChDir(OldDir);
  Init;
end;

Procedure WordBufferO.ClrScr;
begin
  oldBColor := TextAttr;
  TextAttr := bColor;
  Crt.ClrScr;
  TextAttr := oldBColor;
end;

Procedure WordBufferO.DelLine;
begin
  oldBColor := TextAttr;
  TextAttr := bColor;
  Crt.DelLine;
  TextAttr := oldBColor;
end;

Procedure WordBufferO.InsLine;
begin
  oldBColor := TextAttr;
  TextAttr := bColor;
  Crt.InsLine;
  TextAttr := oldBColor;
end;

Procedure WordBufferO.Edit(maxLineLength : Byte);
var
  cx, cy:	Byte;

Procedure ShiftDown(ss : Word);                               Forward;


Var
  lineLength : Byte;
  yMax, xMax : Byte;

Procedure DownScreen(ss : Word);		{ in Edit }
begin
   if screenPos + bufShiftPos{ - 1} >= buf.Len then else
   if screenPos + ss <= yMax then screenPos := screenPos + ss else
    begin
      ShiftDown(ss - (LongInt(yMax) - screenPos));
      screenPos := yMax;
    end;
end;                             { DownScreen in Edit }

Procedure InsertLine;            { in Edit }
var
  tempstring : string;
begin
  update := True;
  UpD := True;
   if buf.Len = 0 then
    begin
      tempstring := '';
      buf.Add('');
    end
    else begin
      tempstring := buf.Get(bufShiftPos + (screenPos {- 1}));
      buf.Ovr(Split(tempstring, linepos - 1), BufShiftPos + screenPos);
      buf.Ins(tempstring, BufShiftPos + screenPos + 1);
    end;
{  tempstring[0]:= Chr(linepos-1);}
  linepos := 1;
  lineShift := 0;
  DownScreen(1);
end;                             { InsertLine in Edit }

Procedure ShiftDown(ss : Word);  { in Edit }
var
  t:	Word;
begin
  update := True;
   if buf.Len = 0 then
   else if (bufShiftPos + (screenPos{ - 1})) + ss > buf.Len then
    begin
       if bufShiftPos + ss > buf.Len then
	begin
	  t := (bufShiftPos + ss + (yMax - 1)) - buf.Len;
	  bufShiftPos := buf.Len;
	   if t >= screenPos then screenPos := 1
	   else screenPos := screenPos - t;
	end
       else begin
	 bufShiftPos := bufShiftPos + ss;
	  if bufShiftPos + (screenPos -1) > buf.Len then
	  screenPos := buf.Len - (bufShiftPos{ -1});
       end;
    end
    else begin
      bufShiftPos := bufShiftPos + ss
    end;
end;                             { ShiftDown in Edit }

Procedure ShiftScreen;           { in Edit }
var
  x    : Byte;
  y    : Integer;
  tempbs :Word;
  temp : string;
begin
   if buf.Len < 1 then
    begin
      upD := False;
      ClrScr;
      DrectWriteCA(cx, cy, 0, endOfFileChar, cAttr);
    end
   else if (bufShiftPos - OldFilePos = 1)
   and (oldLineShift = lineShift)
   and (upD = false) then
    begin
      GotoXY(1, 1);
      DelLine;
      GotoXY(1, yMax);
{      InsLine;}
       if bufShiftPos + yMax <= buf.Len then
	begin
	  GotoXY(1, yMax);
	  DrectWriteCA(cx, cy + yMax - 1, 0,
	  Copy(buf.Get(bufShiftPos + yMax), lineShift + 1, xMax -1),
	  cAttr);
	end
	else begin
	  GotoXY(1, (buf.Len - bufShiftPos) + 1);
	  DrectWriteCA(cx, cy + ((buf.Len - bufShiftPos)), 0, endOfFileChar, cAttr);
	end;
      GotoXY(LinePos, screenPos);
    end
   else if ((longInt(bufShiftPos) - oldFilePos = -1) and (oldLineShift = lineShift) and (upD = False)) then
    begin
      GotoXY(1, 1);
      InsLine;
      GotoXY(LinePos, 1);
       if bufShiftPos <= buf.Len then
	DrectWriteCA(cx, cy, 0,
	Copy(buf.Get(bufShiftPos + 1), lineshift + 1, xMax - 1),
	cAttr);
      if bufShiftPos + yMax > buf.Len then
       begin
	  if buf.len = 0 then DrectWriteCA(cx, cy, 0, endOfFileChar, cAttr)
	   else begin
	     DrectWriteCA(cx, cy-1 + (buf.Len - bufShiftPos) + 1, 0, endOfFileChar, cAttr);
	   end;
       end;
    end
    else begin
      upD := False;
      ClrScr;
      tempBS := buf.len;
       if yMax > tempBS - (bufShiftPos {- 1})  then y := tempBS- (bufShiftPos{ - 1})
       else y := yMax;
      x := 0;
       for x := 1 to y do
	begin
	  temp := buf.Get(bufShiftPos + x{ - 1});
	  DrectWriteCA(cx, cy-1 + x , 0, Copy(temp, lineshift + 1, xMax - 1), cAttr);
	end;
       GotoXY(1, x);
      if bufShiftPos + (yMax - 1) > buf.Len then
       begin
	 DrectWriteCA(cx, cy-1+x+1, 0, endOfFileChar, cAttr);
       end;
    end;
  OldFilePos := bufShiftPos;
  oldLineShift := lineShift;
  update := False;
end;                             { ShiftScreen in Edit }

Procedure ShiftUp(ss : Word);    { in Edit }
begin
   if bufShiftPos = 0 then
    begin
      if LongInt(screenPos) - ss < 1 then screenPos := 1 else
      screenPos := screenPos - ss;
    end
    else begin
      update := True;
       if LongInt(bufShiftPos) - ss < 1 then bufShiftPos := 0
       else bufShiftPos := bufShiftPos - ss;
    end;
end;                             { ShiftUp in Edit }

Procedure UpScreen(ss : Word);   { in Edit }
begin
   if bufShiftPos + screenPos{ - 1} <= 1 then else
   if LongInt(screenPos) - ss >= 1 then screenPos := screenPos - ss else
    begin
      ShiftUp(ss - (screenPos-1));
      screenPos := 1;
    end;
end;                             { UpScreen in Edit }

Var
  tempLine : String;
Label skip;
begin                            { Edit }
  InOutZ;
   if (infoToX > 0) and (infoToY > 0) then
    begin
      iTX := infoToX;
      iTY := infoToY;
      oldLL := 0;
      tempP := ReadLineProc2;
      ReadLineProc2 := WriteInfoP;
    end;
  FileYesNo := True;
  update := True;
  yMax := WindDepth(0,0);
   if yMax < 2 then InOut(532, 10, 386);
  xMax := WindWidth(0,0);
  GotoXY(1, 1);
  cx := GetCursorX(0);
  cy := GetCursorY(0);
  LastKey := '';
    repeat
       if screenPos > buf.len then screenPos := buf.Len;
       if screenPos < 1 then screenPos := 1;
       if bufShiftPos + screenPos{ - 1} > Buf.Len then
	begin
	   if screenPos > 1 then
	   if (bufShiftPos + screenPos{ - 1}) - Buf.Len <= screenPos{ -1} then
	   screenPos := screenPos - ((bufShiftPos + screenPos{ - 1}) - Buf.Len)
	   else screenPos := 1
	end;
       if bufShiftPos + screenPos{ - 1} > Buf.Len then
	begin
	   if bufShiftPos > 0 then
	    begin
	       if (bufShiftPos + screenPos{ - 1}) - Buf.Len <= bufShiftPos then
	       bufShiftPos := bufShiftPos - ((bufShiftPos + screenPos{ - 1}) - Buf.Len)
	       else bufShiftPos := 0;
	    end;
	end;
      GotoXY(LinePos+1,screenPos);
       if (not KeyPressed) and update then ShiftScreen;
      _EditLine.editFilePos := bufShiftPos + (ScreenPos{ - 1});
      _EditLine.lineShift   := lineShift;
      _EditLine.fileLength  := buf.Len;
      _EditLine.linePos     := linePos;
      GotoXY(WhereX, ScreenPos);
       if buf.Len > 0 then
       tempLine := ReadLine(buf.Get(bufShiftPos + screenPos{ - 1}),
			    maxLineLength)
       else tempLine := ReadLine('', maxLineLength);
      DrectWriteCA(cx, cy-1+ScreenPos, 0,
		   Copy(tempLine, lineshift + 1, xMax - 1),
		   cAttr);
{      DrectWriteCA(cx, cy-1+ScreenPos, 0,
		   Copy(buf.Get(bufShiftPos + screenPos - 1),
			lineshift + 1, xMax - 1),
		   cAttr);}
       if (buf.Len = 0) and (tempLine <> '')
       or ((buf.Len > 0)
	   and (buf.get(bufShiftPos + screenPos{ - 1}) <> tempLine)) then
	begin
	  buf.Ovr(tempLine, bufShiftPos + screenPos{ - 1});
	  saved := False;
	end;
       if lineShift <> _EditLine.LineShift then
	begin
	  update := True;
	  lineShift := _EditLine.LineShift;
	end;
      linePos := _EditLine.linePos;
       if LastKey = Enter then
	begin
	  InsertLine;
	  saved := False;
	  goto skip;
	end
       else if (LastKey = up) or (LastKey = ^e) then UpScreen(1)
       else if (LastKey = Down) or (LastKey = ^x) then DownScreen(1)
       else if (LastKey = ^w) then ShiftUp(1)
       else if (LastKey = ^z) then ShiftDown(1)
       else if (LastKey = PgUp) or (LastKey = ^r) then ShiftUp(yMax)
       else if (LastKey = PgDn) or (LastKey = ^c) then ShiftDown(yMax) else
       if LastKey = ^h then
	begin
	  if bufShiftPos + screenPos - 1 > 0 then
	   begin
	     linePos := Length(buf.Get(bufShiftPos + screenPos - 1)) + 1;
	      if linePos < 1 then linePos := 1
	      else if linePos > xMax - 1 then lineShift := linePos - (xMax-1);
	     buf.Ovr(buf.Get(bufShiftPos + screenPos - 1)+
		     buf.Get(bufShiftPos + screenPos),
		     bufShiftPos + screenPos - 1);
	     buf.Del(bufShiftPos + screenPos);
	     Saved := False;
	     upDate := True;
	     upD := True;
	   end;
	  UpScreen(1);
	end else
       if LastKey = ^y then
	begin
	   if Buf.Len >= bufShiftPos + screenPos then
	    begin
	      update := True;
	      Saved := False;
	      buf.Del(bufShiftPos + screenPos);
	    end;
	end else
       if (LastKey = ^g) or (LastKey = Del) then
	begin
	   if bufShiftPos + screenPos + 1 <= buf.Len then
	    begin
	      upD := True;
	      buf.Ovr(buf.Get(bufShiftPos + screenPos)+
		      buf.Get(bufShiftPos + screenPos + 1),
		      bufShiftPos + screenPos);
	      Buf.Del(bufShiftPos + screenPos + 1);
	      Saved := False;
	      upD := True;
	      upDate := True;
	    end;
{	  DownScreen(1);}
	end
       else if (LastKey = cPgUp) or (LastKey = ^q+'W') then
	begin
	   if bufShiftPos = 1 then screenPos := 1
	    else begin
	      update := True;
	      bufShiftPos := 1;
	      screenPos := 1;
	    end;
	  linePos := 1;
	  lineShift := 0;
	  update := True;
	end
       else if LastKey = cPgdn then
	begin
	   if bufShiftPos - (yMax - 1) = buf.Len then screenPos := yMax
	    else begin
	      update := True;
	       if buf.Len = 0 then
		begin
		  bufShiftPos := 1;
		  screenPos := 1;
		end
	       else if buf.Len <= ymax then
		begin
		  bufShiftPos := 1;
		  screenPos := buf.Len;
		end
		else begin
		  bufShiftPos := buf.Len - (ymax - 1);
		  screenPos := yMax;
		end;
	    end;
	   if buf.Len = 0 then linePos := 1 else
	   linePos := Length(buf.Get(bufShiftPos + (ScreenPos - 1))) + 1;
	   if linePos < 1 then linePos := 1
	   else if linePos > xMax - 1 then lineShift := linePos - (xMax-1);
	end;
       if (LastKey = f2) or (LastKey = ^k+'S')
	  or (LastKey = ^k+'X') then WordBufferO.Save;
skip:
    Until (LastKey = Esc) or (LastKey = ^k+'X');
  _EditLine.editFilePos := 1;
  _EditLine.LineShift   := 0;
  _EditLine.fileLength  := 1;
  _EditLine.linePos     := 1;
  FileYesNo        := False;
   if (infoToX > 0) and (infoToY > 0) then
    begin
      iTX := infoToX;
      iTY := infoToY;
      ReadLineProc2 := tempP;
    end;
end;                          { Edit }

Procedure WordBufferO.WriteInfoTo(x, y: Word);
begin
  infoToX := x;
  infoToY := y;
end;

Function WordBufferO.Install(f : ComStr): Boolean;
var
  error		:Word;
Begin
  Init;
  Install := True;
  ClrScr;
  OldDir := CToFileDir(f);
  saved := True;
  error := loadbuffer(buf, FileNameExt(f));
   if error = 0 then name := FileNameExt(f) else
    begin
      ChDir(OldDir);
      Message(' Message ', ErrorCode(error), ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1, ErrorRec.EDelay2);
      {ClrScr;
      DrectWriteCA('Can not open file: ', f);}
      Install := False;
    end;
end;

Procedure WordBufferO.Save;
var
  fs     : text;
  x      : Byte;
  OldDirT : DirStr;
  temp   : String;
  t      : Boolean;
begin
  OldDirT := CToFileDir(Name);
    repeat
      t := True;
      {$I-}
      Assign(fs, name);
      Rewrite(fs);
      {$I+}
       if DosError > 0 then
        begin
          DosE;
	  Message(' Error ', ' Abort / Retry ', ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1,
		  ErrorRec.EDelay2);
	  if Not (UpCase(ReadKey) = 'A') then t := False;
	end;
    Until t;
   if ctrlZ then buf.Ovr(buf.Get(buf.Len)+ ^Z, buf.Len);
   for x := 1 to buf.Len do
    begin
      temp := buf.Get(x);
      WriteLn(fs,temp);
    end;
  Close(fs);
  saved := True;
  ChDir(OldDirT);
end;

Procedure WordBufferO.SetCtrlZ;
begin
  ctrlZ := True;
end;

Procedure WordBufferO.UnSetCtrlZ;
begin
  ctrlZ := False;
end;

Function WordBufferO.Updated : Boolean;
begin
  Updated := saved;
end;
{*****************************End editBufferO****************************}

END.