unit _score;

//{$WARN UNSAFE_TYPE OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Calendar, StdCtrls, Buttons, _Buffers, _String, Menus, ComCtrls,
  Spin;

type
  TScoreForm = class(TForm)
    line1: TLabel;
    line2: TLabel;
    line3: TLabel;
    line4: TLabel;
    line5: TLabel;
    line6: TLabel;
    line7: TLabel;
    line8: TLabel;
    line9: TLabel;
    line10: TLabel;
    ShiftLabel: TLabel;
    CloseBtn: TBitBtn;
    SortTypyButton: TButton;
    BitBtn4: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Name1: TMenuItem;
    Date1: TMenuItem;
    Score1: TMenuItem;
    entrys: TLabel;
    StatusBar1: TStatusBar;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure SortTypyButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Name1Click(Sender: TObject);
    procedure Date1Click(Sender: TObject);
    procedure Score1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure scroll(by: Integer);
  public
    { Public declarations }
  end;

var
  ScoreForm: TScoreForm;
  closeButton: Boolean = false;


//Procedure ShowScore(B:BufferO);

implementation

Procedure UpdateScore;				Forward;
Procedure SortOrder;                            Forward;

var
  ScrollV: Word;
  buf: BufferO;
  order:(nameO,score,date) = date;

{$R *.DFM}

Procedure TScoreForm.Scroll(by: Integer);
begin
   if scrollV+by <= 0 then ScrollV := 0
   else if scrollV + by > buf.Len then scrollV := buf.len
   else scrollV := scrollV + by;
  UpdateScore;
end;

Procedure ShowScore(B:BufferO);
var
  x: word;
begin
  buf := BufferO.Create;
  ScoreForm.entrys.Caption := IntToStr(B.Len)+' entries';
  ScrollV := 0;
   for x := 1 to B.len do buf.Add(b.Get(x));
  //ScoreForm.Label1.Caption := 'Order added to db';
  order := Score;
  SortOrder;
  UpdateScore;
  ScoreForm.ShowModal;// Visible := true;
  buf.Destroy;
end;

Procedure UpdateScore;

Procedure HiLight(var label1 :TLabel;s:string);
begin
   if FindFirstC(s,'*') = 1 then
    begin
      s := DelFirst(s, 1);
      label1.Font.Color := $00FDDBAC;//clRed;
      label1.Font.Style := [];//[fsBold];
      label1.Color := clGreen;
    end
    else begin
      label1.Color := clBtnFace;
      label1.Font.Style := [];
      label1.Font.Color := clWindowText;
    end;
  label1.Caption  := s;
end;

function GetS(n:word):string;
begin
  n:=n;
   if (ScrollV+n  > Buf.len) then result := 'Empty'
   else result := buf.get(ScrollV+n);
end;


begin
with ScoreForm do
  begin
  ShiftLabel.Caption := 'Scroll ' + intToStr(ScrollV);
  HiLight(line1,  getS(1));
  HiLight(line2,  getS(2));
  HiLight(line3,  getS(3));
  HiLight(line4,  getS(4));
  HiLight(line5,  getS(5));
  HiLight(line6,  getS(6));
  HiLight(line7,  getS(7));
  HiLight(line8,  getS(8));
  HiLight(line9,  getS(9));
  HiLight(line10, getS(10));
  end;
end;

procedure TScoreForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  buf.Destroy;
  ScoreForm.ModalResult:= mrOk;// .Visible := False;
end;


procedure TScoreForm.CancelButtonClick(Sender: TObject);
begin
  closeButton := True;
  Close;
end;

procedure TScoreForm.BitBtn1Click(Sender: TObject);
begin
  Scroll(-8);
end;

procedure TScoreForm.BitBtn2Click(Sender: TObject);
begin
  Scroll(8);
end;

procedure TScoreForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  Scroll(-1);
  Handled := true;
end;

procedure TScoreForm.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
   Scroll(1);
   Handled := true;
end;

function DateTimeInOrder(s1,s2:string):Boolean;
var
  date1, date2, {time1, time2,} day, month, year	:string;
begin
  s1 := DelAllButK(s1,c0To9+'@/');
  s2 := DelAllButK(s2,c0To9+'@/');
  date1 := SplitK3(s1,'@');
  //time1 := s1;
  date2 := SplitK3(s2,'@');
  //time2 := s2;
  day := SplitK2(date1,'/');
  month := SplitK2(date1,'/');
  year := date1;
  s1 := year + month + day + s1;
  day := SplitK2(date2,'/');
  month := SplitK2(date2,'/');
  year := date2;
  s2 := year + month + day + s2;
  result :=  s1 >= s2;
end;

procedure DateSortSubFunc(sortedTo:Word);
var
  x,maxPos,minPos:word;
  t1,t2:string;
begin
  if sortedTo >= 2 then
    begin
      minPos := 1;
      maxPos := sortedTo;
      t1 := CopyLast(buf.Get(sortedTo +1), 19);
      repeat
	x := (maxPos + minPos) div 2;
	t2 := CopyLast(buf.Get(x), 19);
	if DateTimeInOrder(t1,t2) then
	  maxPos := x
	else minPos := x + 1;
      until (maxPos <= minPos);// or (x = 1);
//      saveBuffer(buf,'c:\temp\o1');
      buf.Move(sortedTo +1,minPos);
//      saveBuffer(buf,'c:\temp\o2');
    end
  else if sortedTo = 1 then
    begin
      buf.Move(2,1);
    end;
end;

Procedure SortOrder;
var
  x		:word;
  y:word;
  swaped	:Boolean;
  T1, T2	:STRING;
begin
  if buf.Len < 2 then exit;
  if order = nameO then
   begin
     order := score;
     ScoreForm.label1.Caption:= 'Name';
     buf.Sort;
     UpdateScore;
   end
  else if order = score then
    begin
      order := date;
      ScoreForm.label1.Caption:= 'Score';
      y := 0;
       repeat
	 swaped := false;
	 for x := 1 to (buf.Len - 1) - y do
	   begin
	     if CopyfromFor(buf.Get(x),'%',3,True) <
		CopyfromFor(buf.Get(x+1),'%',3,True)
	     then begin
	       swaped := true;
	       saveBuffer(buf,'c:\temp\o1.pas');
	       buf.Swop(x,x+1);
	       saveBuffer(buf,'c:\temp\o2.pas');
	     end;
	   end;
	 inc(y);
       until swaped = false;
       UpdateScore;
    end
  else if order = date then
    begin
      order := nameO;
      ScoreForm.label1.Caption:= 'Date';
       for x := 1 to buf.Len - 1 do
	 begin
	   t1 := CopyLast(buf.Get(x), 19);
	   t2 := CopyLast(buf.Get(x+1), 19);
	   if not DateTimeInOrder(t1,t2)
	   then begin
	     DateSortSubFunc(x);
	   end;
	 end;
       UpdateScore;
    end;
end;

procedure TScoreForm.SortTypyButtonClick(Sender: TObject);
begin
  SortOrder;
end;

procedure TScoreForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   if closeButton then
    begin
      CanClose := true;
      closeButton := false;
    end
    else begin
      CanClose := False;
      MessageDlg('Please use close button', mtWarning, [mbOk],0);
    end;
end;

procedure TScoreForm.Name1Click(Sender: TObject);
begin
  order := nameO;
  SortOrder;
end;

procedure TScoreForm.Date1Click(Sender: TObject);
begin
  order := Date;
  SortOrder;
end;

procedure TScoreForm.Score1Click(Sender: TObject);
begin
  order := Score;
  SortOrder;
end;

procedure TScoreForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_NEXT then
    begin
      key := 0;
      BitBtn2Click(Sender);
    end
  else if key = VK_Prior then
    begin
      key := 0;
      BitBtn1Click(Sender);
    end;
end;

procedure TScoreForm.FormShow(Sender: TObject);
begin
  ScoreForm.CloseBtn.SetFocus;
end;

end. //    'jmnc2%100 or   7/7   on the 03/10/2000@11:04:48'
