Unit SLQueue;
Interface
type
  itemType	= Integer; {This is the type stored in the queue}

  elementPtr	= ^element;{a pointer to an element in the linked list}

  element 	= record		{an element of the linked list}
		    i: itemType;	{the item being stored}
		    next: elementPtr;   {a pointer to the next record in the
					linked list(set to nil if there is
					no next record)}
		  end;

  queue	= record		{the main record of a queue}
	    size:	Word;   {the current size of the linked list}
	    maxSize:	Word;   {the maximum size of the linked list}
	    first:	elementPtr;{a pointer to the first storage
				element of said linked list}
	  end;

  

  {The possible errors return by some of the procedures}
  errorType	= (error_empty_queue, error_full_queue, Ok);

  Procedure CreateSLQueue(maxSize: word; var q: queue);
  Procedure Front(q: queue; var i: itemType; var e: errorType);
  Procedure AddToSLQueue(i:itemType; q: queue; var q2: queue; var e: errorType);
  Procedure DeleteFromSLQueue(q: queue; var q2: queue; var e: errorType);
	{if diferent queue variabes are past to q and q2 the data in q
	 will be invalied affter return from AddToSLQueue & DeleteFromSLQueue}
  Procedure IsEmptySLQueue(q: queue; var b: Boolean);
  Procedure IsSLQueueFull(q: queue; var b: Boolean);
  Procedure SLQueueSize(q: queue; var size: Word);
  Procedure MaxSLQSize(q: queue; var maxSize: Word);



Implementation


  Procedure CreateSLQueue(maxSize: word; var q: queue);
  {set up a new empty queue with a size limit of maxsize and pass it back in q}
  begin
    q.size := 0;	{set the size of a new queue the 0}
    q.maxSize := maxSize;	{set the size limit of the new queue}
    q.first := nil;	{set the pointer to the first element to nil}
  end;

  Procedure Front(q: queue; var i: itemType; var e: errorType);
  {return the first item in the queue in i}
  begin
    e := Ok;
    if  q.size <= 0 then e := error_empty_queue
    else i := q.first^.i;
  end;

  Procedure AddToSLQueue(i:itemType; q: queue; var q2: queue; var e: errorType);
  var
    NewR, qRec: elementPtr;	{pointers to queue elements}
    qSize, x: Word;
    b:	Boolean;
  begin
    IsSLQueueFull(q,b);
    if b <> true then		{if the queue is not full then}
      begin
	e := Ok; 		{set the returned error to Ok}
	new(newR);              {get space on heap}
	IsEmptySLQueue(q,b);
	if b then		{if the queue is empty then}
	q.first := newR	{set the first element pointer}
	  else begin                    {else find the last element}
	    SLQueueSize(q, qSize);
	    qRec := q.first;
	    for x := 1 to qSize do qRec := qRec^.next;
	    qRec^.next := newR;		{and set the last element to point to
					the new one}
	  end;
	q.size := q.size + 1;	{make the new element the last one}
	newR^.next := nil;
	newR^.i := i;     		{set the item of the new element}
      end
      else begin
	e := error_full_queue;          {return an error}
      end;
    q2 := q;

  end;

  Procedure DeleteFromSLQueue(q: queue; var q2: queue; var e: errorType);
  {delete the first item from the queue}
  var
    qSize: Word;
  begin
    SLQueueSize(q, qSize);
    if qSize > 0 then	{if queue not empty}
      begin		{delete first element}
	e := Ok;
	q.first := q.first^.next;{remove the first element from list}
	Dispose(q.first);		{return the mem to the heap}
	q.size := q.size - 1;	{set queue size}
      end
      else begin
	e := error_empty_queue;		{retern error}
      end;
    q2 := q;
  end;

  Procedure IsEmptySLQueue(q: queue; var b: Boolean);
  {Returns true in b if the queue given by 'q' is empty}
  begin
    b := (q.size = 0);
  end;

  Procedure IsSLQueueFull(q: queue; var b: Boolean);
  {if the queue (q) is full then return true (in b) else return false}
  begin
    b := (q.size >= q.maxSize);{set the return varable}
  end;

  Procedure SLQueueSize(q: queue; var size: Word);
  {returns the current size of the queue in size}
  begin
    size := q.size;
  end;

  Procedure MaxSLQSize(q: queue; var maxSize: Word);
  {returns the maxumum number of items that can be stored in the
  queue in maxSize}
  begin
    maxSize := q.maxSize;
  End;



End.

