unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, IBDatabase,
  DB, IBCustomDataSet, IBTable, DBCtrls, IBQuery, Mask, IBSQL, Printers;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    HelpContentsItem: TMenuItem;
    HelpSearchItem: TMenuItem;
    HelpHowToUseItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    StatusLine: TStatusBar;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    PrintSetupDialog: TPrinterSetupDialog;
    SpeedBar: TPanel;
    SpeedButton1: TSpeedButton;  { &New }
    SpeedButton2: TSpeedButton;  { &Open... }
    SpeedButton3: TSpeedButton;  { &Save }
    SpeedButton4: TSpeedButton;  { &Print... }
    SpeedButton5: TSpeedButton;  { P&rint Setup... }
    SpeedButton6: TSpeedButton;  { E&xit }
    SpeedButton7: TSpeedButton;  { &Undo }
    SpeedButton8: TSpeedButton;  { Cu&t }
    SpeedButton9: TSpeedButton;  { &Copy }
    SpeedButton10: TSpeedButton;  { &Paste }
    SpeedButton11: TSpeedButton;
    DataSource1: TDataSource;
    IBTable1: TIBTable;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    DBComboBox1: TDBComboBox;
    DBEdit1: TDBEdit;
    DBComboBox3: TDBComboBox;
    DBComboBox4: TDBComboBox;
    DBEdit2: TDBEdit;
    DBComboBox5: TDBComboBox;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    DBText3: TDBText;
    DBText4: TDBText;
    Label18: TLabel;
    Label19: TLabel;
    DBText5: TDBText;
    DBText6: TDBText;
    Label20: TLabel;
    Label21: TLabel;
    DBText7: TDBText;
    DBText8: TDBText;
    Label22: TLabel;
    Label23: TLabel;
    DBText9: TDBText;
    DBText10: TDBText;
    Label24: TLabel;
    Label25: TLabel;
    DBText11: TDBText;
    DBText12: TDBText;
    Label26: TLabel;
    Label27: TLabel;
    DBText13: TDBText;
    DBText14: TDBText;
    DBComboBox6: TDBComboBox;
    DBComboBox7: TDBComboBox;
    DBComboBox8: TDBComboBox;
    DBComboBox9: TDBComboBox;
    Label28: TLabel;
    Label29: TLabel;
    IBQuery1: TIBQuery;
    DataSource2: TDataSource;
    IBSQL1: TIBSQL;
    BitBtn1: TBitBtn;
    IBDataSet1: TIBDataSet;
    BitBtn2: TBitBtn;
    DBCheckBox1: TDBCheckBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    DBRadioGroup2: TDBRadioGroup;  { &Contents }
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FilePrintSetup(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure HelpContents(Sender: TObject);
    procedure HelpSearch(Sender: TObject);
    procedure HelpHowToUse(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure IBTable1AfterScroll(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
       Button: TNavigateBtn);
    procedure IBTable1AfterInsert(DataSet: TDataSet);
    procedure IBDataSet1BeforePost(DataSet: TDataSet);
    procedure IBDataSet1BeforeEdit(DataSet: TDataSet);
    procedure IBTable1AfterDelete(DataSet: TDataSet);
  private
    procedure AddRecored;
    procedure LocateLastInsterted;
    Function GetValues:string;
  end;

const
  FN = 'NAME, CHAMPION, KC_NO, SIRE_KC_NO, DAM_KC_NO, DATE_OF_BIRTH,'+
       'DATE_OF_REG, BREEDER, PET_NAME, COLOUR, SEX, OWNER, BREED';
var
  MainForm: TMainForm;
  lastId:Integer;

implementation

{$r *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FileNew(Sender: TObject);
begin
  { Add code to create a new file }
end;

procedure TMainForm.FileOpen(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    { Add code to open OpenDialog.FileName }
  end;
end;

procedure TMainForm.FileSave(Sender: TObject);
begin
   { Add code to save current file under current name }
end;

procedure TMainForm.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    { Add code to save current file under SaveDialog.FileName }
  end;
end;

procedure TMainForm.FilePrint(Sender: TObject);
var
  r: TRect;
  i: Integer;
begin
  if PrintDialog.Execute then
  begin
    with Printer do
      begin
        r := Rect(1,1, (MainForm.Width),(MainForm.Height));
        BeginDoc;
        NewPage;
//        Canvas.
        Canvas.CopyRect(r, MainForm.Canvas, r);
//        Canvas.Assign(MainForm.Canvas);
{        Canvas.Brush.Style := bsClear;
        for i := 0 to Memo1.Lines.Count do
         Canvas.TextOut(200,200 + (i *
                     Canvas.TextHeight(Memo1.Lines.Strings[i])),
                     Memo1.Lines.Strings[i]);

        Canvas.Brush.Color := clBlack;
        Canvas.FrameRect(r);}
        EndDoc;
      end;
    { Add code to print current file }
  end;
end;

procedure TMainForm.FilePrintSetup(Sender: TObject);
begin
  PrintSetupDialog.Execute;
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditUndo(Sender: TObject);
begin
  { Add code to perform Edit Undo }
end;

procedure TMainForm.EditCut(Sender: TObject);
begin
  { Add code to perform Edit Cut }
end;

procedure TMainForm.EditCopy(Sender: TObject);
begin
  { Add code to perform Edit Copy }
end;

procedure TMainForm.EditPaste(Sender: TObject);
begin
  { Add code to perform Edit Paste }
end;

procedure TMainForm.HelpContents(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TMainForm.HelpSearch(Sender: TObject);
const
  EmptyString: PChar = '';
begin
  Application.HelpCommand(HELP_PARTIALKEY, Longint(EmptyString));
end;

procedure TMainForm.HelpHowToUse(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TMainForm.HelpAbout(Sender: TObject);
begin
  { Add code to show program's About Box }
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  DBNavigator1.Enabled := False;
  IBSQL1.ExecQuery;
  IBTransaction1.CommitRetaining;
end;

procedure TMainForm.IBTable1AfterScroll(DataSet: TDataSet);
begin
  if IBTable1.Fields.FieldByName('CHAMPION').IsNull then
    begin
      IBTable1.Edit;
      IBTable1.Fields.FieldByName('CHAMPION').AsInteger := 0;
    end;
end;

procedure TMainForm.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
  if Button in [{nbFirst, nbPrior, nbNext, nbLast,}
                nbInsert{, nbDelete, nbEdit, nbPost}] then
    begin
      AddRecored;
      LocateLastInsterted;
      Abort;
    end
  else if Button = nbCancel then IBDataSet1.Transaction.RollbackRetaining
  else if (Button in [nbFirst, nbPrior, nbNext, nbLast, nbPost])
    and (IBTable1.Modified) then
    begin
      IBDataSet1.Transaction.CommitRetaining;
    end;
end;

procedure TMainForm.IBTable1AfterInsert(DataSet: TDataSet);
begin
  IBTable1.Edit;
end;

procedure TMainForm.AddRecored;
begin
  IBDataSet1.SelectSQL.Text := 'insert into dogs (CHAMPION) values (''0'')';
  IBDataSet1.ExecSQL;// Insert;
end;

procedure TMainForm.LocateLastInsterted;
var
  sql: String;
  id: Integer;
begin
  IBDataSet1.Close;
  IBDataSet1.SelectSQL.Text := 'select * from dogs ORDER BY ID DESC';
  IBDataSet1.Open;
  lastId := IBDataSet1.FieldByName('ID').AsInteger;
  IBTable1.Refresh;
  IBTable1.Locate('ID', lastId, []);
  IBTable1.Edit;
end;

function TMainForm.GetValues:String;
var
  s:string;
begin
  s := IBDataSet1.FieldByName('NAME').AsString; //NAME
  s := s + ',' + IBDataSet1.FieldByName('CHAMPION').AsString; //CHAMPION
  s := s + ',' + IBDataSet1.FieldByName('KC_NO').AsString; //KC_NO
  s := s + ',' + IBDataSet1.FieldByName('SIRE_KC_NO').AsString; //SIRE_KC_NO
  s := s + ',' + IBDataSet1.FieldByName('DAM_KC_NO').AsString; //DAM_KC_NO
  s := s + ',' + IBDataSet1.FieldByName('DATE_OF_BIRTH').AsString; //DATE_OF_BIRTH
  s := s + ',' + IBDataSet1.FieldByName('DATE_OF_REG').AsString; //DATE_OF_REG
  s := s + ',' + IBDataSet1.FieldByName('BREEDER').AsString; //BREEDER
  s := s + ',' + IBDataSet1.FieldByName('PET_NAME').AsString; //PET_NAME
  s := s + ',' + IBDataSet1.FieldByName('COLOUR').AsString; //COLOUR
  s := s + ',' + IBDataSet1.FieldByName('SEX').AsString; //SEX
  s := s + ',' + IBDataSet1.FieldByName('OWNER').AsString; //OWNER
  s := s + ',' + IBDataSet1.FieldByName('BREED').AsString; //BREED
end;


procedure TMainForm.IBDataSet1BeforePost(DataSet: TDataSet);
var
  sql, s:String;
begin
  sql := 'UPDATE dogs set ';
  if not DataSet.FieldByName('NAME').IsNull then
    s := 'NAME = ' + DataSet.FieldByName('NAME').AsString //NAME
  else s := 'NAME = Null';
  if not DataSet.FieldByName('CHAMPION').IsNull then
    s := s + ', CHAMPION = ' + DataSet.FieldByName('CHAMPION').AsString; //CHAMPION
  if not DataSet.FieldByName('KC_NO').IsNull then
    s := s + ', KC_NO = ' + DataSet.FieldByName('KC_NO').AsString; //KC_NO
  if not DataSet.FieldByName('SIRE_KC_NO').IsNull then
    s := s + ', SIRE_KC_NO = ' + DataSet.FieldByName('SIRE_KC_NO').AsString; //SIRE_KC_NO
  if not DataSet.FieldByName('DAM_KC_NO').IsNull then
    s := s + ', DAM_KC_NO = ' + DataSet.FieldByName('DAM_KC_NO').AsString; //DAM_KC_NO
  if not DataSet.FieldByName('DATE_OF_BIRTH').IsNull then
    s := s + ', DATE_OF_BIRTH = ' + DataSet.FieldByName('DATE_OF_BIRTH').AsString; //DATE_OF_BIRTH
  if not DataSet.FieldByName('DATE_OF_REG').IsNull then
    s := s + ', DATE_OF_REG = ' + DataSet.FieldByName('DATE_OF_REG').AsString; //DATE_OF_REG
  if not DataSet.FieldByName('BREEDER').IsNull then
    s := s + ', BREEDER = ' + DataSet.FieldByName('BREEDER').AsString; //BREEDER
  if not DataSet.FieldByName('PET_NAME').IsNull then
    s := s + ', PET_NAME = ' + DataSet.FieldByName('PET_NAME').AsString; //PET_NAME
  if not DataSet.FieldByName('COLOUR').IsNull then
    s := s + ', COLOUR = ' + DataSet.FieldByName('COLOUR').AsString; //COLOUR
  if not DataSet.FieldByName('SEX').IsNull then
    s := s + ', SEX = ' + DataSet.FieldByName('SEX').AsString; //SEX
  if not DataSet.FieldByName('OWNER').IsNull then
    s := s + ', OWNER = ' + DataSet.FieldByName('OWNER').AsString; //OWNER
  if not DataSet.FieldByName('BREED').IsNull then
    s := s + ', BREED = ' + DataSet.FieldByName('BREED').AsString; //BREED
  sql := sql + s;
  sql := sql + ' WHERE ID = '+ DataSet.FieldByName('ID').AsString;
//  DataSet.ModifySQL.Clear;
//  DataSet.ModifySQL.Add(sql);;
end;

procedure TMainForm.IBDataSet1BeforeEdit(DataSet: TDataSet);
begin
  IBDataSet1BeforePost(DataSet);
end;

procedure TMainForm.IBTable1AfterDelete(DataSet: TDataSet);
begin
  IBDataSet1.Transaction.CommitRetaining;
end;

end.
