unit ConvertScore;
{}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Menus, Db, DBTables, Grids, DBGrids, _String, _Buffers, IBCustomDataSet,
  IBTable, ExtCtrls, DBCtrls, IBDatabase, StdCtrls, Buttons, IBSQL,_Dos, Dialogs;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    StartDir1: TMenuItem;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    IBTable1: TIBTable;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DataSource1: TDataSource;
    IBSQL1: TIBSQL;
    BitBtn1: TBitBtn;
    procedure StartDir1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  StartDir:String;

implementation

{$R *.DFM}

Function SQLQuotes(s:string):string;
begin
  result := '';
   while length(s) > 0 do
    begin
       if InStringC(s,#39) then
	Result := Result + SplitK2(s, #39) + #39#39
       else begin
	 Result := Result + s;
	 s := '';
       end;
    end;
end;


Procedure AddSqlString(var s:string;add:String);
begin
   if InStringC(add, #39) then
    begin
      add := SQLQuotes(add);
    end;
   if s <> '' then s := s + ', ';
  s:= s + #39 + add + #39;
end;

procedure ConvertScoreFile(f:String);
var
  buf: BufferO;
  colls, values, s1, sql: String;
  x:Word;
begin
  buf.init;
  loadBuffer(buf, f);
   for x := 1 to buf.len do
    begin
      sql := '';
      colls := '';
      values := '';
      s1 := buf.Get(x);
      //DelAllK(sql,#10#13^Z^C#39); //no ' aloud in string
       if InString(s1,'&') then
	begin
	  AddSQLString(values, SplitK2(s1, '&'));//name
	  AddSQLString(values, SplitK2(s1, '$'));//date
	  colls := 'name, date1';
	end
	else begin
	  AddSQLString(values, SplitK2(s1, '$')); //name
	  colls := 'name';
	end;
       if values <> '' then values := values + ', ';
      values := values + SplitK2(s1, ':');// score
      values := values + ', ' + SplitK2(s1, '%');//maxHelp
       if colls <> '' then colls := colls + ', ';
      colls := colls + 'score, max_help';
       if inString(s1, ';') then
	begin
	  values := values + ', ' + SplitK2(s1, ';'); //total
	  AddSQLString(values, s1);//time
	  colls := colls + ', word_count, time';
	end
	else begin
	  values := values + ', ' + s1; //total
	  colls := colls + ', word_count';
	  //timeS := '';
	end;
      colls := colls + ', file1';
      AddSqlString(values,DelFirst(f,Length(StartDir)));
      sql := 'INSERT INTO score (' + colls + ') VALUES (' + values + ');';
      form1.IBSQL1.SQL.Text := sql;
      form1.IBSQL1.ExecQuery;
    end;
//  ShowScore(buf);
  buf.Done;
end;


Procedure LoadList(f:string);
var
  SearchRec:	TSearchRec;
  found:		Integer;
begin
  f:=DelTrailing(f,'\')+'\';
    Found := FindFirst(f+'*.*', faDirectory, SearchRec);
    while Found = 0 do
    begin//sco
       if SUpCase(FileExt(SearchRec.Name)) = 'SCO' then
	begin
	   if SearchRec.Attr <> faDirectory then
	    begin
	      ConvertScoreFile(f+SearchRec.Name);
	    end;
	end
       else if SUpCase(FileExt(SearchRec.Name)) = 'SPL' then
	begin
	   if SearchRec.Attr = faDirectory then LoadList(f+SearchRec.Name);
	end;
      Found := FindNext(SearchRec);
    end;
end;


procedure TForm1.StartDir1Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
    begin
      OpenDialog1.FileName := 'C:\Program Files\Spl6\spl.spl\';
      startdir := OpenDialog1.FileName;
      LoadList(OpenDialog1.FileName);
       if Form1.IBTransaction1.InTransaction then
	begin
	  Form1.IBTransaction1.Commit;
	end;
      MessageDlg('Finished Adding sql', mtInformation ,[mbOK], 0);
    end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  ibsql1.ExecQuery;
   if IBTransaction1.InTransaction then
    begin
      IBTransaction1.Commit;
    end;
end;

end.
